/* Favicon.c generated by valac 0.56.17, the Vala compiler
 * generated from Favicon.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */
/**
 * @file Favicon.vala
 * @author technosf
 * @date 2024-10-01
 * @brief Get, cache and serve favicons
 * @version 1.5.4
 *
 * This file contains the Tuner.Favicon class, which handles the retrieval,
 * caching, and serving of favicons for radio stations.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_FAVICON (tuner_favicon_get_type ())
#define TUNER_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_FAVICON, TunerFavicon))
#define TUNER_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_FAVICON, TunerFaviconClass))
#define TUNER_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_FAVICON))
#define TUNER_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_FAVICON))
#define TUNER_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_FAVICON, TunerFaviconClass))

typedef struct _TunerFavicon TunerFavicon;
typedef struct _TunerFaviconClass TunerFaviconClass;
typedef struct _TunerFaviconPrivate TunerFaviconPrivate;
enum  {
	TUNER_FAVICON_0_PROPERTY,
	TUNER_FAVICON_NUM_PROPERTIES
};
static GParamSpec* tuner_favicon_properties[TUNER_FAVICON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _TunerFaviconLoadAsyncData TunerFaviconLoadAsyncData;

struct _TunerFavicon {
	GObject parent_instance;
	TunerFaviconPrivate * priv;
};

struct _TunerFaviconClass {
	GObjectClass parent_class;
};

struct _TunerFaviconLoadAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerModelStation* station;
	gboolean forceReload;
	GdkPixbuf* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gchar* favicon_cache_file;
	TunerApplication* _tmp8_;
	TunerApplication* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gboolean _tmp15_;
	const gchar* _tmp16_;
	GdkPixbuf* _tmp17_;
	const gchar* _tmp18_;
	GdkPixbuf* _tmp19_;
	GdkPixbuf* _tmp20_;
	GError* e;
	GError* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	guint status_code;
	GInputStream* stream;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	guint _tmp28_;
	GInputStream* _tmp29_;
	gboolean _tmp30_;
	GInputStream* _tmp31_;
	GdkPixbuf* pixbuf;
	GInputStream* _tmp32_;
	GdkPixbuf* _tmp33_;
	GdkPixbuf* scaled_pixbuf;
	GdkPixbuf* _tmp34_;
	GdkPixbuf* _tmp35_;
	GdkPixbuf* _tmp36_;
	const gchar* _tmp37_;
	GError* _vala1_e;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	GError* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	GError* _inner_error0_;
};

static gpointer tuner_favicon_parent_class = NULL;

VALA_EXTERN GType tuner_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerFavicon, g_object_unref)
static void tuner_favicon_load_async_data_free (gpointer _data);
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN void tuner_favicon_load_async (TunerModelStation* station,
                               gboolean forceReload,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN GdkPixbuf* tuner_favicon_load_finish (GAsyncResult* _res_);
static gboolean tuner_favicon_load_async_co (TunerFaviconLoadAsyncData* _data_);
VALA_EXTERN const gchar* tuner_model_station_get_favicon_url (TunerModelStation* self);
VALA_EXTERN gboolean tuner_model_station_get_favicon_load_error (TunerModelStation* self);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
VALA_EXTERN const gchar* tuner_application_get_cache_dir (TunerApplication* self);
VALA_EXTERN const gchar* tuner_model_station_get_id (TunerModelStation* self);
VALA_EXTERN void tuner_http_client_GETasync (const gchar* url_string,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN GInputStream* tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                                 guint* status_code);
static void tuner_favicon_load_async_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
VALA_EXTERN void tuner_model_station_set_favicon_load_error (TunerModelStation* self,
                                                 gboolean value);
VALA_EXTERN TunerFavicon* tuner_favicon_new (void);
VALA_EXTERN TunerFavicon* tuner_favicon_construct (GType object_type);
static GType tuner_favicon_get_type_once (void);

static void
tuner_favicon_load_async_data_free (gpointer _data)
{
	TunerFaviconLoadAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->station);
	_g_object_unref0 (_data_->result);
	g_slice_free (TunerFaviconLoadAsyncData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
tuner_favicon_load_async (TunerModelStation* station,
                          gboolean forceReload,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	TunerFaviconLoadAsyncData* _data_;
	TunerModelStation* _tmp0_;
	g_return_if_fail (station != NULL);
	_data_ = g_slice_new0 (TunerFaviconLoadAsyncData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_favicon_load_async_data_free);
	_tmp0_ = _g_object_ref0 (station);
	_g_object_unref0 (_data_->station);
	_data_->station = _tmp0_;
	_data_->forceReload = forceReload;
	tuner_favicon_load_async_co (_data_);
}

GdkPixbuf*
tuner_favicon_load_finish (GAsyncResult* _res_)
{
	GdkPixbuf* result;
	TunerFaviconLoadAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

/**
     * @brief Asynchronously load the favicon for a given station
     *
     * This method attempts to load the favicon from the cache first. If not found in the cache
     * or if forceReload is true, it will fetch the favicon from the internet asynchronously
     * scale it to 48x48 pixels, and save it to a cache file.
     *
     * @param station The station for which to load the favicon
     * @param forceReload If true, bypass the cache and fetch the favicon from the internet
     * @return The loaded favicon as a Gdk.Pixbuf, or null if loading fails
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
tuner_favicon_load_async_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	TunerFaviconLoadAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	tuner_favicon_load_async_co (_data_);
}

static gboolean
tuner_favicon_load_async_co (TunerFaviconLoadAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp2_ = tuner_model_station_get_favicon_url (_data_->station);
	_data_->_tmp3_ = _data_->_tmp2_;
	if (_data_->_tmp3_ == NULL) {
		_data_->_tmp1_ = TRUE;
	} else {
		_data_->_tmp4_ = tuner_model_station_get_favicon_url (_data_->station);
		_data_->_tmp5_ = _data_->_tmp4_;
		_data_->_tmp1_ = g_strcmp0 (_data_->_tmp5_, "") == 0;
	}
	if (_data_->_tmp1_) {
		_data_->_tmp0_ = TRUE;
	} else {
		_data_->_tmp6_ = tuner_model_station_get_favicon_load_error (_data_->station);
		_data_->_tmp7_ = _data_->_tmp6_;
		_data_->_tmp0_ = _data_->_tmp7_;
	}
	if (_data_->_tmp0_) {
		_data_->result = NULL;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp8_ = tuner_application_get_instance ();
	_data_->_tmp9_ = _data_->_tmp8_;
	_data_->_tmp10_ = tuner_application_get_cache_dir (_data_->_tmp9_);
	_data_->_tmp11_ = _data_->_tmp10_;
	_data_->_tmp12_ = tuner_model_station_get_id (_data_->station);
	_data_->_tmp13_ = _data_->_tmp12_;
	_data_->_tmp14_ = g_build_filename (_data_->_tmp11_, _data_->_tmp13_, NULL);
	_data_->favicon_cache_file = _data_->_tmp14_;
	if (!_data_->forceReload) {
		_data_->_tmp16_ = _data_->favicon_cache_file;
		_data_->_tmp15_ = g_file_test (_data_->_tmp16_, G_FILE_TEST_EXISTS);
	} else {
		_data_->_tmp15_ = FALSE;
	}
	if (_data_->_tmp15_) {
		{
			_data_->_tmp18_ = _data_->favicon_cache_file;
			_data_->_tmp19_ = gdk_pixbuf_new_from_file_at_scale (_data_->_tmp18_, 48, 48, TRUE, &_data_->_inner_error0_);
			_data_->_tmp17_ = _data_->_tmp19_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_data_->_tmp20_ = _data_->_tmp17_;
			_data_->_tmp17_ = NULL;
			_data_->result = _data_->_tmp20_;
			_g_object_unref0 (_data_->_tmp17_);
			_g_free0 (_data_->favicon_cache_file);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp21_ = _data_->e;
			_data_->_tmp22_ = _data_->_tmp21_->message;
			_data_->_tmp23_ = string_to_string (_data_->_tmp22_);
			_data_->_tmp24_ = g_strconcat ("Failed to load cached favicon: ", _data_->_tmp23_, NULL);
			_data_->_tmp25_ = _data_->_tmp24_;
			g_warning ("Favicon.vala:52: %s", _data_->_tmp25_);
			_g_free0 (_data_->_tmp25_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->favicon_cache_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp26_ = tuner_model_station_get_favicon_url (_data_->station);
	_data_->_tmp27_ = _data_->_tmp26_;
	_data_->_tmp28_ = 0U;
	_data_->_state_ = 1;
	tuner_http_client_GETasync (_data_->_tmp27_, tuner_favicon_load_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp29_ = tuner_http_client_GETasync_finish (_data_->_res_, &_data_->_tmp28_);
	_data_->status_code = _data_->_tmp28_;
	_data_->stream = _data_->_tmp29_;
	_data_->_tmp31_ = _data_->stream;
	if (_data_->_tmp31_ != NULL) {
		_data_->_tmp30_ = _data_->status_code == ((guint) 200);
	} else {
		_data_->_tmp30_ = FALSE;
	}
	if (_data_->_tmp30_) {
		{
			_data_->_tmp32_ = _data_->stream;
			_data_->_state_ = 2;
			gdk_pixbuf_new_from_stream_async (_data_->_tmp32_, NULL, tuner_favicon_load_async_ready, _data_);
			return FALSE;
			_state_2:
			_data_->_tmp33_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
			_data_->pixbuf = _data_->_tmp33_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
			_data_->_tmp34_ = _data_->pixbuf;
			_data_->_tmp35_ = gdk_pixbuf_scale_simple (_data_->_tmp34_, 48, 48, GDK_INTERP_BILINEAR);
			_data_->scaled_pixbuf = _data_->_tmp35_;
			_data_->_tmp36_ = _data_->scaled_pixbuf;
			_data_->_tmp37_ = _data_->favicon_cache_file;
			gdk_pixbuf_save (_data_->_tmp36_, _data_->_tmp37_, "png", &_data_->_inner_error0_, NULL);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				_g_object_unref0 (_data_->scaled_pixbuf);
				_g_object_unref0 (_data_->pixbuf);
				goto __catch1_g_error;
			}
			_data_->result = _data_->scaled_pixbuf;
			_g_object_unref0 (_data_->pixbuf);
			_g_object_unref0 (_data_->stream);
			_g_free0 (_data_->favicon_cache_file);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		goto __finally1;
		__catch1_g_error:
		{
			_data_->_vala1_e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp38_ = tuner_model_station_get_favicon_url (_data_->station);
			_data_->_tmp39_ = _data_->_tmp38_;
			_data_->_tmp40_ = string_to_string (_data_->_tmp39_);
			_data_->_tmp41_ = _data_->_vala1_e;
			_data_->_tmp42_ = _data_->_tmp41_->message;
			_data_->_tmp43_ = string_to_string (_data_->_tmp42_);
			_data_->_tmp44_ = g_strconcat ("Failed to process favicon ", _data_->_tmp40_, " - ", _data_->_tmp43_, NULL);
			_data_->_tmp45_ = _data_->_tmp44_;
			g_warning ("Favicon.vala:71: %s", _data_->_tmp45_);
			_g_free0 (_data_->_tmp45_);
			_g_error_free0 (_data_->_vala1_e);
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->stream);
			_g_free0 (_data_->favicon_cache_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	tuner_model_station_set_favicon_load_error (_data_->station, TRUE);
	_data_->result = NULL;
	_g_object_unref0 (_data_->stream);
	_g_free0 (_data_->favicon_cache_file);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

TunerFavicon*
tuner_favicon_construct (GType object_type)
{
	TunerFavicon * self = NULL;
	self = (TunerFavicon*) g_object_new (object_type, NULL);
	return self;
}

TunerFavicon*
tuner_favicon_new (void)
{
	return tuner_favicon_construct (TUNER_TYPE_FAVICON);
}

static void
tuner_favicon_class_init (TunerFaviconClass * klass,
                          gpointer klass_data)
{
	tuner_favicon_parent_class = g_type_class_peek_parent (klass);
}

static void
tuner_favicon_instance_init (TunerFavicon * self,
                             gpointer klass)
{
}

/**
 * @brief Get, cache and serve favicons
 *
 * This class handles the retrieval, caching, and serving of favicons for radio stations.
 * It provides methods to load favicons from cache or fetch them from the internet.
 *
 * @class Tuner.Favicon
 * @extends Object
 */
static GType
tuner_favicon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerFaviconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_favicon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerFavicon), 0, (GInstanceInitFunc) tuner_favicon_instance_init, NULL };
	GType tuner_favicon_type_id;
	tuner_favicon_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerFavicon", &g_define_type_info, 0);
	return tuner_favicon_type_id;
}

GType
tuner_favicon_get_type (void)
{
	static volatile gsize tuner_favicon_type_id__once = 0;
	if (g_once_init_enter (&tuner_favicon_type_id__once)) {
		GType tuner_favicon_type_id;
		tuner_favicon_type_id = tuner_favicon_get_type_once ();
		g_once_init_leave (&tuner_favicon_type_id__once, tuner_favicon_type_id);
	}
	return tuner_favicon_type_id__once;
}

