/* HttpClient.c generated by valac 0.56.17, the Vala compiler
 * generated from HttpClient.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */
/**
 * @file HttpClient.vala
 * @author technosf
 * @date 2024-10-01
 * @since 1.5.4
 * @brief HTTP client implementation using Soup library
 */

#include <glib-object.h>
#include <libsoup/soup.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define TUNER_APPLICATION_APP_ID "com.github.louis77.tuner"
#define VERSION "1.5.5"
#define TUNER_APPLICATION_APP_VERSION VERSION
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_HTTP_CLIENT (tuner_http_client_get_type ())
#define TUNER_HTTP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_HTTP_CLIENT, TunerHttpClient))
#define TUNER_HTTP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_HTTP_CLIENT, TunerHttpClientClass))
#define TUNER_IS_HTTP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_HTTP_CLIENT))
#define TUNER_IS_HTTP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_HTTP_CLIENT))
#define TUNER_HTTP_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_HTTP_CLIENT, TunerHttpClientClass))

typedef struct _TunerHttpClient TunerHttpClient;
typedef struct _TunerHttpClientClass TunerHttpClientClass;
typedef struct _TunerHttpClientPrivate TunerHttpClientPrivate;
enum  {
	TUNER_HTTP_CLIENT_0_PROPERTY,
	TUNER_HTTP_CLIENT_NUM_PROPERTIES
};
static GParamSpec* tuner_http_client_properties[TUNER_HTTP_CLIENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _tuner_http_client_GETasyncData tuner_http_client_GETasyncData;

struct _TunerHttpClient {
	GObject parent_instance;
	TunerHttpClientPrivate * priv;
};

struct _TunerHttpClientClass {
	GObjectClass parent_class;
};

struct _tuner_http_client_GETasyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* url_string;
	guint status_code;
	GInputStream* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp4_;
	gchar* sanitized_url;
	gchar* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GError* e;
	GError* _tmp9_;
	const gchar* _tmp10_;
	SoupMessage* msg;
	const gchar* _tmp11_;
	SoupMessage* _tmp12_;
	SoupMessage* _tmp13_;
	GInputStream* inputStream;
	SoupSession* _tmp14_;
	SoupSession* _tmp15_;
	SoupMessage* _tmp16_;
	GInputStream* _tmp17_;
	GInputStream* _tmp18_;
	SoupMessage* _tmp19_;
	guint _tmp20_;
	guint _tmp21_;
	GError* _vala1_e;
	const gchar* _tmp22_;
	GError* _tmp23_;
	const gchar* _tmp24_;
	GError* _inner_error0_;
};

static gpointer tuner_http_client_parent_class = NULL;
static SoupSession* tuner_http_client__session;
static SoupSession* tuner_http_client__session = NULL;

VALA_EXTERN GType tuner_http_client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerHttpClient, g_object_unref)
static SoupSession* tuner_http_client_getSession (void);
VALA_EXTERN GInputStream* tuner_http_client_GET (const gchar* url_string,
                                     guint* status_code);
static gchar* tuner_http_client_ensure_https_prefix (const gchar* url);
static gboolean __lambda25_ (SoupMessage* msg,
                      GTlsCertificate* cert,
                      GTlsCertificateFlags errors);
static gboolean ___lambda25__soup_message_accept_certificate (SoupMessage* _sender,
                                                       GTlsCertificate* tls_peer_certificate,
                                                       GTlsCertificateFlags tls_peer_errors,
                                                       gpointer self);
static void tuner_http_client_GETasync_data_free (gpointer _data);
VALA_EXTERN void tuner_http_client_GETasync (const gchar* url_string,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN GInputStream* tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                                 guint* status_code);
static gboolean tuner_http_client_GETasync_co (tuner_http_client_GETasyncData* _data_);
static gboolean __lambda10_ (SoupMessage* msg,
                      GTlsCertificate* cert,
                      GTlsCertificateFlags errors);
static gboolean ___lambda10__soup_message_accept_certificate (SoupMessage* _sender,
                                                       GTlsCertificate* tls_peer_certificate,
                                                       GTlsCertificateFlags tls_peer_errors,
                                                       gpointer self);
static void tuner_http_client_GETasync_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
VALA_EXTERN TunerHttpClient* tuner_http_client_new (void);
VALA_EXTERN TunerHttpClient* tuner_http_client_construct (GType object_type);
static void tuner_http_client_finalize (GObject * obj);
static GType tuner_http_client_get_type_once (void);

/**
     * @brief Get the singleton Soup.Session instance
     *
     * This method returns the singleton Soup.Session instance, creating it
     * if it doesn't already exist. The session is configured with a custom
     * user agent string and a timeout of 2 seconds, maximum 30 connections
     * with only one connection per host.
     * 
     *
     * @return The singleton Soup.Session instance
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static SoupSession*
tuner_http_client_getSession (void)
{
	SoupSession* _tmp0_;
	SoupSession* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	SoupSession* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	SoupSession* _tmp14_;
	SoupSession* _tmp15_;
	SoupSession* result;
	_tmp0_ = tuner_http_client__session;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		SoupSession* _tmp5_;
		_tmp1_ = string_to_string (TUNER_APPLICATION_APP_ID);
		_tmp2_ = string_to_string (TUNER_APPLICATION_APP_VERSION);
		_tmp3_ = g_strconcat (_tmp1_, "/", _tmp2_, NULL);
		_tmp4_ = _tmp3_;
		_tmp5_ = soup_session_new_with_options ("max-conns", 50, "max-conns-per-host", 2, "timeout", 3, "user_agent", _tmp4_, NULL);
		_g_object_unref0 (tuner_http_client__session);
		tuner_http_client__session = _tmp5_;
		_g_free0 (_tmp4_);
	}
	_tmp6_ = tuner_http_client__session;
	_tmp7_ = g_strdup_printf ("%u", soup_session_get_max_conns (_tmp6_));
	_tmp8_ = _tmp7_;
	_tmp9_ = tuner_http_client__session;
	_tmp10_ = g_strdup_printf ("%u", soup_session_get_max_conns_per_host (_tmp9_));
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat ("Conns Max: ", _tmp8_, ", Conns PH: ", _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	g_debug ("HttpClient.vala:56: %s", _tmp13_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	_tmp14_ = tuner_http_client__session;
	_tmp15_ = _g_object_ref0 (_tmp14_);
	result = _tmp15_;
	return result;
}

/**
     * @brief Perform a GET request to the specified URL
     *
     * @param url_string The URL to send the GET request to
     * @param status_code Output parameter for the HTTP status code of the response
     * @return InputStream containing the response body, or null if the request failed
     * @throws Error if there's an error sending the request or receiving the response
     */
static gboolean
__lambda25_ (SoupMessage* msg,
             GTlsCertificate* cert,
             GTlsCertificateFlags errors)
{
	gboolean result;
	g_return_val_if_fail (msg != NULL, FALSE);
	g_return_val_if_fail (cert != NULL, FALSE);
	result = TRUE;
	return result;
}

static gboolean
___lambda25__soup_message_accept_certificate (SoupMessage* _sender,
                                              GTlsCertificate* tls_peer_certificate,
                                              GTlsCertificateFlags tls_peer_errors,
                                              gpointer self)
{
	gboolean result;
	result = __lambda25_ (_sender, tls_peer_certificate, tls_peer_errors);
	return result;
}

GInputStream*
tuner_http_client_GET (const gchar* url_string,
                       guint* status_code)
{
	guint _vala_status_code = 0U;
	gboolean _tmp0_ = FALSE;
	gchar* sanitized_url = NULL;
	gchar* _tmp4_;
	SoupMessage* msg = NULL;
	const gchar* _tmp5_;
	SoupMessage* _tmp6_;
	SoupMessage* _tmp7_;
	GError* _inner_error0_ = NULL;
	GInputStream* result;
	g_return_val_if_fail (url_string != NULL, NULL);
	_vala_status_code = (guint) 0;
	if (url_string == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (url_string);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_ < 4;
	}
	if (_tmp0_) {
		const gchar* _tmp3_ = NULL;
		_tmp3_ = url_string;
		if (_tmp3_ == NULL) {
			_tmp3_ = "null";
		}
		g_warning ("HttpClient.vala:74: GET - Invalid URL: %s", _tmp3_);
		result = NULL;
		if (status_code) {
			*status_code = _vala_status_code;
		}
		return result;
	}
	_tmp4_ = tuner_http_client_ensure_https_prefix (url_string);
	sanitized_url = _tmp4_;
	_tmp5_ = sanitized_url;
	_tmp6_ = soup_message_new ("GET", _tmp5_);
	msg = _tmp6_;
	_tmp7_ = msg;
	g_signal_connect (_tmp7_, "accept-certificate", (GCallback) ___lambda25__soup_message_accept_certificate, NULL);
	{
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp9_;
		_tmp9_ = sanitized_url;
		_tmp8_ = g_uri_is_valid (_tmp9_, G_URI_FLAGS_NONE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		if (_tmp8_) {
			GInputStream* inputStream = NULL;
			SoupSession* _tmp10_;
			SoupSession* _tmp11_;
			SoupMessage* _tmp12_;
			GInputStream* _tmp13_;
			GInputStream* _tmp14_;
			SoupMessage* _tmp15_;
			guint _tmp16_;
			guint _tmp17_;
			_tmp10_ = tuner_http_client_getSession ();
			_tmp11_ = _tmp10_;
			_tmp12_ = msg;
			_tmp13_ = soup_session_send (_tmp11_, _tmp12_, NULL, &_inner_error0_);
			_tmp14_ = _tmp13_;
			_g_object_unref0 (_tmp11_);
			inputStream = _tmp14_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp15_ = msg;
			g_object_get (_tmp15_, "status-code", &_tmp16_, NULL);
			_tmp17_ = _tmp16_;
			_vala_status_code = _tmp17_;
			result = inputStream;
			_g_object_unref0 (msg);
			_g_free0 (sanitized_url);
			if (status_code) {
				*status_code = _vala_status_code;
			}
			return result;
		} else {
			const gchar* _tmp18_;
			_tmp18_ = sanitized_url;
			g_debug ("HttpClient.vala:97: GET - Invalid URL format: %s", _tmp18_);
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp19_ = sanitized_url;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		g_warning ("HttpClient.vala:100: GET - Error accessing URL: %s (%s)", _tmp19_, _tmp21_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (msg);
		_g_free0 (sanitized_url);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = NULL;
	_g_object_unref0 (msg);
	_g_free0 (sanitized_url);
	if (status_code) {
		*status_code = _vala_status_code;
	}
	return result;
}

static void
tuner_http_client_GETasync_data_free (gpointer _data)
{
	tuner_http_client_GETasyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->url_string);
	_g_object_unref0 (_data_->result);
	g_slice_free (tuner_http_client_GETasyncData, _data_);
}

void
tuner_http_client_GETasync (const gchar* url_string,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	tuner_http_client_GETasyncData* _data_;
	gchar* _tmp0_;
	g_return_if_fail (url_string != NULL);
	_data_ = g_slice_new0 (tuner_http_client_GETasyncData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_http_client_GETasync_data_free);
	_tmp0_ = g_strdup (url_string);
	_g_free0 (_data_->url_string);
	_data_->url_string = _tmp0_;
	tuner_http_client_GETasync_co (_data_);
}

GInputStream*
tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                   guint* status_code)
{
	GInputStream* result;
	tuner_http_client_GETasyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	if (status_code) {
		*status_code = _data_->status_code;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

/**
     * @brief Perform an asynchronous GET request to the specified URL
     *
     * @param url_string The URL to send the GET request to
     * @param status_code Output parameter for the HTTP status code of the response
     * @return InputStream containing the response body, or null if the request failed
     */
static gboolean
__lambda10_ (SoupMessage* msg,
             GTlsCertificate* cert,
             GTlsCertificateFlags errors)
{
	gboolean result;
	g_return_val_if_fail (msg != NULL, FALSE);
	g_return_val_if_fail (cert != NULL, FALSE);
	result = TRUE;
	return result;
}

static gboolean
___lambda10__soup_message_accept_certificate (SoupMessage* _sender,
                                              GTlsCertificate* tls_peer_certificate,
                                              GTlsCertificateFlags tls_peer_errors,
                                              gpointer self)
{
	gboolean result;
	result = __lambda10_ (_sender, tls_peer_certificate, tls_peer_errors);
	return result;
}

static void
tuner_http_client_GETasync_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	tuner_http_client_GETasyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	tuner_http_client_GETasync_co (_data_);
}

static gboolean
tuner_http_client_GETasync_co (tuner_http_client_GETasyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->status_code = (guint) 0;
	if (_data_->url_string == NULL) {
		_data_->_tmp1_ = TRUE;
	} else {
		_data_->_tmp2_ = strlen (_data_->url_string);
		_data_->_tmp3_ = _data_->_tmp2_;
		_data_->_tmp1_ = _data_->_tmp3_ < 4;
	}
	if (_data_->_tmp1_) {
		_data_->_tmp0_ = TRUE;
	} else {
		_data_->_tmp0_ = g_strcmp0 (_data_->url_string, "null") == 0;
	}
	if (_data_->_tmp0_) {
		_data_->_tmp4_ = _data_->url_string;
		if (_data_->_tmp4_ == NULL) {
			_data_->_tmp4_ = "null";
		}
		g_debug ("HttpClient.vala:121: GETasync - Invalid URL: %s", _data_->_tmp4_);
		_data_->result = NULL;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp5_ = tuner_http_client_ensure_https_prefix (_data_->url_string);
	_data_->sanitized_url = _data_->_tmp5_;
	{
		_data_->_tmp7_ = _data_->sanitized_url;
		_data_->_tmp6_ = g_uri_is_valid (_data_->_tmp7_, G_URI_FLAGS_NONE, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == G_URI_ERROR) {
				goto __catch0_g_uri_error;
			}
			_g_free0 (_data_->sanitized_url);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		if (!_data_->_tmp6_) {
			_data_->_tmp8_ = _data_->sanitized_url;
			g_debug ("HttpClient.vala:129: GETasync - Invalid URL format: %s", _data_->_tmp8_);
			_data_->result = NULL;
			_g_free0 (_data_->sanitized_url);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	goto __finally0;
	__catch0_g_uri_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp9_ = _data_->e;
		_data_->_tmp10_ = _data_->_tmp9_->message;
		g_debug ("HttpClient.vala:133: GETasync - URI error: %s", _data_->_tmp10_);
		_data_->result = NULL;
		_g_error_free0 (_data_->e);
		_g_free0 (_data_->sanitized_url);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_free0 (_data_->sanitized_url);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp11_ = _data_->sanitized_url;
	_data_->_tmp12_ = soup_message_new ("GET", _data_->_tmp11_);
	_data_->msg = _data_->_tmp12_;
	_data_->_tmp13_ = _data_->msg;
	g_signal_connect (_data_->_tmp13_, "accept-certificate", (GCallback) ___lambda10__soup_message_accept_certificate, NULL);
	{
		_data_->_tmp14_ = tuner_http_client_getSession ();
		_data_->_tmp15_ = _data_->_tmp14_;
		_data_->_tmp16_ = _data_->msg;
		_data_->_state_ = 1;
		soup_session_send_async (_data_->_tmp15_, _data_->_tmp16_, G_PRIORITY_DEFAULT, NULL, tuner_http_client_GETasync_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp17_ = soup_session_send_finish (_data_->_tmp15_, _data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp18_ = _data_->_tmp17_;
		_g_object_unref0 (_data_->_tmp15_);
		_data_->inputStream = _data_->_tmp18_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_data_->_tmp19_ = _data_->msg;
		g_object_get (_data_->_tmp19_, "status-code", &_data_->_tmp20_, NULL);
		_data_->_tmp21_ = _data_->_tmp20_;
		_data_->status_code = _data_->_tmp21_;
		_data_->result = _data_->inputStream;
		_g_object_unref0 (_data_->msg);
		_g_free0 (_data_->sanitized_url);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	goto __finally1;
	__catch1_g_error:
	{
		_data_->_vala1_e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp22_ = _data_->sanitized_url;
		_data_->_tmp23_ = _data_->_vala1_e;
		_data_->_tmp24_ = _data_->_tmp23_->message;
		g_warning ("HttpClient.vala:153: GETasync - Couldn't fetch resource: %s (%s)", _data_->_tmp22_, _data_->_tmp24_);
		_g_error_free0 (_data_->_vala1_e);
	}
	__finally1:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->msg);
		_g_free0 (_data_->sanitized_url);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = NULL;
	_g_object_unref0 (_data_->msg);
	_g_free0 (_data_->sanitized_url);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

/**
     * @brief Ensures that the given URL has an HTTPS prefix
     *
     * This method checks if the provided URL starts with either "http://" or "https://".
     * If it doesn't have either prefix, it adds "https://" to the beginning of the URL.
     *
     * @param url The input URL string to be checked and potentially modified
     * @return A string representing the URL with an HTTPS prefix
     *
     * @note This method does not validate the URL structure beyond checking for the protocol prefix
     */
static gchar*
tuner_http_client_ensure_https_prefix (const gchar* url)
{
	gboolean _tmp0_ = FALSE;
	gchar* _tmp2_;
	gchar* result;
	g_return_val_if_fail (url != NULL, NULL);
	if (!g_str_has_prefix (url, "http://")) {
		_tmp0_ = !g_str_has_prefix (url, "https://");
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp1_;
		_tmp1_ = g_strconcat ("https://", url, NULL);
		result = _tmp1_;
		return result;
	}
	_tmp2_ = g_strdup (url);
	result = _tmp2_;
	return result;
}

TunerHttpClient*
tuner_http_client_construct (GType object_type)
{
	TunerHttpClient * self = NULL;
	self = (TunerHttpClient*) g_object_new (object_type, NULL);
	return self;
}

TunerHttpClient*
tuner_http_client_new (void)
{
	return tuner_http_client_construct (TUNER_TYPE_HTTP_CLIENT);
}

static void
tuner_http_client_class_init (TunerHttpClientClass * klass,
                              gpointer klass_data)
{
	tuner_http_client_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = tuner_http_client_finalize;
}

static void
tuner_http_client_instance_init (TunerHttpClient * self,
                                 gpointer klass)
{
}

static void
tuner_http_client_finalize (GObject * obj)
{
	TunerHttpClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_HTTP_CLIENT, TunerHttpClient);
	G_OBJECT_CLASS (tuner_http_client_parent_class)->finalize (obj);
}

/**
 * @class Tuner.HttpClient
 * @brief HTTP functions abstracting Soup library
 *
 * This class provides static methods for making HTTP requests using the Soup library.
 * It includes a singleton Soup.Session instance for efficient request handling.
 */
static GType
tuner_http_client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerHttpClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_http_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerHttpClient), 0, (GInstanceInitFunc) tuner_http_client_instance_init, NULL };
	GType tuner_http_client_type_id;
	tuner_http_client_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerHttpClient", &g_define_type_info, 0);
	return tuner_http_client_type_id;
}

GType
tuner_http_client_get_type (void)
{
	static volatile gsize tuner_http_client_type_id__once = 0;
	if (g_once_init_enter (&tuner_http_client_type_id__once)) {
		GType tuner_http_client_type_id;
		tuner_http_client_type_id = tuner_http_client_get_type_once ();
		g_once_init_leave (&tuner_http_client_type_id__once, tuner_http_client_type_id);
	}
	return tuner_http_client_type_id__once;
}

