/* RadioBrowser.c generated by valac 0.56.17, the Vala compiler
 * generated from RadioBrowser.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <json-glib/json-glib.h>

#define TUNER_RADIO_BROWSER_SRV_SERVICE "api"
#define TUNER_RADIO_BROWSER_SRV_PROTOCOL "tcp"
#define TUNER_RADIO_BROWSER_SRV_DOMAIN "radio-browser.info"
#define TUNER_RADIO_BROWSER_ALL_API "https://all.api.radio-browser.info"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_RADIO_BROWSER_TYPE_STATION (tuner_radio_browser_station_get_type ())
#define TUNER_RADIO_BROWSER_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_RADIO_BROWSER_TYPE_STATION, TunerRadioBrowserStation))
#define TUNER_RADIO_BROWSER_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_RADIO_BROWSER_TYPE_STATION, TunerRadioBrowserStationClass))
#define TUNER_RADIO_BROWSER_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_RADIO_BROWSER_TYPE_STATION))
#define TUNER_RADIO_BROWSER_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_RADIO_BROWSER_TYPE_STATION))
#define TUNER_RADIO_BROWSER_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_RADIO_BROWSER_TYPE_STATION, TunerRadioBrowserStationClass))

typedef struct _TunerRadioBrowserStation TunerRadioBrowserStation;
typedef struct _TunerRadioBrowserStationClass TunerRadioBrowserStationClass;
typedef struct _TunerRadioBrowserStationPrivate TunerRadioBrowserStationPrivate;
enum  {
	TUNER_RADIO_BROWSER_STATION_0_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_STATIONUUID_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_NAME_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_URL_RESOLVED_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_COUNTRY_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_COUNTRYCODE_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_FAVICON_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_CLICKCOUNT_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_HOMEPAGE_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_CODEC_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_BITRATE_PROPERTY,
	TUNER_RADIO_BROWSER_STATION_NUM_PROPERTIES
};
static GParamSpec* tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_RADIO_BROWSER_TYPE_SEARCH_PARAMS (tuner_radio_browser_search_params_get_type ())
typedef struct _TunerRadioBrowserSearchParams TunerRadioBrowserSearchParams;
typedef enum  {
	TUNER_RADIO_BROWSER_SORT_ORDER_NAME,
	TUNER_RADIO_BROWSER_SORT_ORDER_URL,
	TUNER_RADIO_BROWSER_SORT_ORDER_HOMEPAGE,
	TUNER_RADIO_BROWSER_SORT_ORDER_FAVICON,
	TUNER_RADIO_BROWSER_SORT_ORDER_TAGS,
	TUNER_RADIO_BROWSER_SORT_ORDER_COUNTRY,
	TUNER_RADIO_BROWSER_SORT_ORDER_STATE,
	TUNER_RADIO_BROWSER_SORT_ORDER_LANGUAGE,
	TUNER_RADIO_BROWSER_SORT_ORDER_VOTES,
	TUNER_RADIO_BROWSER_SORT_ORDER_CODEC,
	TUNER_RADIO_BROWSER_SORT_ORDER_BITRATE,
	TUNER_RADIO_BROWSER_SORT_ORDER_LASTCHECKOK,
	TUNER_RADIO_BROWSER_SORT_ORDER_LASTCHECKTIME,
	TUNER_RADIO_BROWSER_SORT_ORDER_CLICKTIMESTAMP,
	TUNER_RADIO_BROWSER_SORT_ORDER_CLICKCOUNT,
	TUNER_RADIO_BROWSER_SORT_ORDER_CLICKTREND,
	TUNER_RADIO_BROWSER_SORT_ORDER_RANDOM
} TunerRadioBrowserSortOrder;

#define TUNER_RADIO_BROWSER_TYPE_SORT_ORDER (tuner_radio_browser_sort_order_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNER_RADIO_BROWSER_TYPE_DATA_ERROR (tuner_radio_browser_data_error_get_type ())

#define TUNER_RADIO_BROWSER_TYPE_TAG (tuner_radio_browser_tag_get_type ())
#define TUNER_RADIO_BROWSER_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_RADIO_BROWSER_TYPE_TAG, TunerRadioBrowserTag))
#define TUNER_RADIO_BROWSER_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_RADIO_BROWSER_TYPE_TAG, TunerRadioBrowserTagClass))
#define TUNER_RADIO_BROWSER_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_RADIO_BROWSER_TYPE_TAG))
#define TUNER_RADIO_BROWSER_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_RADIO_BROWSER_TYPE_TAG))
#define TUNER_RADIO_BROWSER_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_RADIO_BROWSER_TYPE_TAG, TunerRadioBrowserTagClass))

typedef struct _TunerRadioBrowserTag TunerRadioBrowserTag;
typedef struct _TunerRadioBrowserTagClass TunerRadioBrowserTagClass;
typedef struct _TunerRadioBrowserTagPrivate TunerRadioBrowserTagPrivate;
enum  {
	TUNER_RADIO_BROWSER_TAG_0_PROPERTY,
	TUNER_RADIO_BROWSER_TAG_NAME_PROPERTY,
	TUNER_RADIO_BROWSER_TAG_STATIONCOUNT_PROPERTY,
	TUNER_RADIO_BROWSER_TAG_NUM_PROPERTIES
};
static GParamSpec* tuner_radio_browser_tag_properties[TUNER_RADIO_BROWSER_TAG_NUM_PROPERTIES];

#define TUNER_RADIO_BROWSER_TYPE_CLIENT (tuner_radio_browser_client_get_type ())
#define TUNER_RADIO_BROWSER_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_RADIO_BROWSER_TYPE_CLIENT, TunerRadioBrowserClient))
#define TUNER_RADIO_BROWSER_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_RADIO_BROWSER_TYPE_CLIENT, TunerRadioBrowserClientClass))
#define TUNER_RADIO_BROWSER_IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_RADIO_BROWSER_TYPE_CLIENT))
#define TUNER_RADIO_BROWSER_IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_RADIO_BROWSER_TYPE_CLIENT))
#define TUNER_RADIO_BROWSER_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_RADIO_BROWSER_TYPE_CLIENT, TunerRadioBrowserClientClass))

typedef struct _TunerRadioBrowserClient TunerRadioBrowserClient;
typedef struct _TunerRadioBrowserClientClass TunerRadioBrowserClientClass;
typedef struct _TunerRadioBrowserClientPrivate TunerRadioBrowserClientPrivate;
enum  {
	TUNER_RADIO_BROWSER_CLIENT_0_PROPERTY,
	TUNER_RADIO_BROWSER_CLIENT_NUM_PROPERTIES
};
static GParamSpec* tuner_radio_browser_client_properties[TUNER_RADIO_BROWSER_CLIENT_NUM_PROPERTIES];
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define __vala_GSrvTarget_free0(var) ((var == NULL) ? NULL : (var = (_vala_GSrvTarget_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

struct _TunerRadioBrowserStation {
	GObject parent_instance;
	TunerRadioBrowserStationPrivate * priv;
};

struct _TunerRadioBrowserStationClass {
	GObjectClass parent_class;
};

struct _TunerRadioBrowserStationPrivate {
	gchar* _stationuuid;
	gchar* _name;
	gchar* _url_resolved;
	gchar* _country;
	gchar* _countrycode;
	gchar* _favicon;
	guint _clickcount;
	gchar* _homepage;
	gchar* _codec;
	gint _bitrate;
};

struct _TunerRadioBrowserSearchParams {
	gchar* text;
	GeeArrayList* tags;
	GeeArrayList* uuids;
	gchar* countrycode;
	TunerRadioBrowserSortOrder order;
	gboolean reverse;
};

/**
     * @brief Error domain for data-related errors
     */
typedef enum  {
	TUNER_RADIO_BROWSER_DATA_ERROR_PARSE_DATA,
	TUNER_RADIO_BROWSER_DATA_ERROR_NO_CONNECTION
} TunerRadioBrowserDataError;
#define TUNER_RADIO_BROWSER_DATA_ERROR tuner_radio_browser_data_error_quark ()

struct _TunerRadioBrowserTag {
	GObject parent_instance;
	TunerRadioBrowserTagPrivate * priv;
};

struct _TunerRadioBrowserTagClass {
	GObjectClass parent_class;
};

struct _TunerRadioBrowserTagPrivate {
	gchar* _name;
	guint _stationcount;
};

struct _TunerRadioBrowserClient {
	GObject parent_instance;
	TunerRadioBrowserClientPrivate * priv;
};

struct _TunerRadioBrowserClientClass {
	GObjectClass parent_class;
};

struct _TunerRadioBrowserClientPrivate {
	gchar* current_server;
};

struct _Block4Data {
	int _ref_count_;
	TunerRadioBrowserClient* self;
	GeeArrayList* stations;
};

struct _Block5Data {
	int _ref_count_;
	TunerRadioBrowserClient* self;
	GeeArrayList* tags;
};

struct _Block6Data {
	int _ref_count_;
	TunerRadioBrowserClient* self;
	GeeArrayList* results;
};

static gint TunerRadioBrowserStation_private_offset;
static gpointer tuner_radio_browser_station_parent_class = NULL;
static gint TunerRadioBrowserTag_private_offset;
static gpointer tuner_radio_browser_tag_parent_class = NULL;
static gint TunerRadioBrowserClient_private_offset;
static gpointer tuner_radio_browser_client_parent_class = NULL;

VALA_EXTERN GType tuner_radio_browser_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerRadioBrowserStation, g_object_unref)
VALA_EXTERN TunerRadioBrowserStation* tuner_radio_browser_station_new (void);
VALA_EXTERN TunerRadioBrowserStation* tuner_radio_browser_station_construct (GType object_type);
VALA_EXTERN const gchar* tuner_radio_browser_station_get_stationuuid (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_stationuuid (TunerRadioBrowserStation* self,
                                                  const gchar* value);
VALA_EXTERN const gchar* tuner_radio_browser_station_get_name (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_name (TunerRadioBrowserStation* self,
                                           const gchar* value);
VALA_EXTERN const gchar* tuner_radio_browser_station_get_url_resolved (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_url_resolved (TunerRadioBrowserStation* self,
                                                   const gchar* value);
VALA_EXTERN const gchar* tuner_radio_browser_station_get_country (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_country (TunerRadioBrowserStation* self,
                                              const gchar* value);
VALA_EXTERN const gchar* tuner_radio_browser_station_get_countrycode (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_countrycode (TunerRadioBrowserStation* self,
                                                  const gchar* value);
VALA_EXTERN const gchar* tuner_radio_browser_station_get_favicon (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_favicon (TunerRadioBrowserStation* self,
                                              const gchar* value);
VALA_EXTERN guint tuner_radio_browser_station_get_clickcount (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_clickcount (TunerRadioBrowserStation* self,
                                                 guint value);
VALA_EXTERN const gchar* tuner_radio_browser_station_get_homepage (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_homepage (TunerRadioBrowserStation* self,
                                               const gchar* value);
VALA_EXTERN const gchar* tuner_radio_browser_station_get_codec (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_codec (TunerRadioBrowserStation* self,
                                            const gchar* value);
VALA_EXTERN gint tuner_radio_browser_station_get_bitrate (TunerRadioBrowserStation* self);
VALA_EXTERN void tuner_radio_browser_station_set_bitrate (TunerRadioBrowserStation* self,
                                              gint value);
static void tuner_radio_browser_station_finalize (GObject * obj);
static GType tuner_radio_browser_station_get_type_once (void);
static void _vala_tuner_radio_browser_station_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_tuner_radio_browser_station_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
VALA_EXTERN GType tuner_radio_browser_search_params_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_radio_browser_sort_order_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TunerRadioBrowserSearchParams* tuner_radio_browser_search_params_dup (const TunerRadioBrowserSearchParams* self);
VALA_EXTERN void tuner_radio_browser_search_params_free (TunerRadioBrowserSearchParams* self);
VALA_EXTERN void tuner_radio_browser_search_params_copy (const TunerRadioBrowserSearchParams* self,
                                             TunerRadioBrowserSearchParams* dest);
VALA_EXTERN void tuner_radio_browser_search_params_destroy (TunerRadioBrowserSearchParams* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TunerRadioBrowserSearchParams, tuner_radio_browser_search_params_destroy)
VALA_EXTERN GQuark tuner_radio_browser_data_error_quark (void);
VALA_EXTERN GType tuner_radio_browser_data_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* tuner_radio_browser_sort_order_to_string (TunerRadioBrowserSortOrder self);
VALA_EXTERN GType tuner_radio_browser_tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerRadioBrowserTag, g_object_unref)
VALA_EXTERN TunerRadioBrowserTag* tuner_radio_browser_tag_new (void);
VALA_EXTERN TunerRadioBrowserTag* tuner_radio_browser_tag_construct (GType object_type);
VALA_EXTERN const gchar* tuner_radio_browser_tag_get_name (TunerRadioBrowserTag* self);
VALA_EXTERN void tuner_radio_browser_tag_set_name (TunerRadioBrowserTag* self,
                                       const gchar* value);
VALA_EXTERN guint tuner_radio_browser_tag_get_stationcount (TunerRadioBrowserTag* self);
VALA_EXTERN void tuner_radio_browser_tag_set_stationcount (TunerRadioBrowserTag* self,
                                               guint value);
static void tuner_radio_browser_tag_finalize (GObject * obj);
static GType tuner_radio_browser_tag_get_type_once (void);
static void _vala_tuner_radio_browser_tag_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_tuner_radio_browser_tag_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
VALA_EXTERN gboolean tuner_radio_browser_EqualCompareString (const gchar* a,
                                                 const gchar* b);
VALA_EXTERN GType tuner_radio_browser_client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerRadioBrowserClient, g_object_unref)
VALA_EXTERN TunerRadioBrowserClient* tuner_radio_browser_client_new (GError** error);
VALA_EXTERN TunerRadioBrowserClient* tuner_radio_browser_client_construct (GType object_type,
                                                               GError** error);
static GeeArrayList* tuner_radio_browser_client_get_api_servers (TunerRadioBrowserClient* self,
                                                          GError** error);
VALA_EXTERN void tuner_radio_browser_client_track (TunerRadioBrowserClient* self,
                                       const gchar* stationuuid);
VALA_EXTERN GInputStream* tuner_http_client_GET (const gchar* url_string,
                                     guint* status_code);
VALA_EXTERN void tuner_radio_browser_client_vote (TunerRadioBrowserClient* self,
                                      const gchar* stationuuid);
VALA_EXTERN GeeArrayList* tuner_radio_browser_client_get_stations (TunerRadioBrowserClient* self,
                                                       const gchar* resource,
                                                       GError** error);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static GeeArrayList* tuner_radio_browser_client_jarray_to_stations (TunerRadioBrowserClient* self,
                                                             JsonArray* data);
VALA_EXTERN GeeArrayList* tuner_radio_browser_client_search (TunerRadioBrowserClient* self,
                                                 TunerRadioBrowserSearchParams* params,
                                                 guint rowcount,
                                                 guint offset,
                                                 GError** error);
VALA_EXTERN TunerRadioBrowserStation* tuner_radio_browser_client_by_uuid (TunerRadioBrowserClient* self,
                                                              const gchar* uuid,
                                                              GError** error);
VALA_EXTERN GeeArrayList* tuner_radio_browser_client_get_tags (TunerRadioBrowserClient* self,
                                                   GError** error);
static GeeArrayList* tuner_radio_browser_client_jarray_to_tags (TunerRadioBrowserClient* self,
                                                         JsonArray* data);
static TunerRadioBrowserStation* tuner_radio_browser_client_jnode_to_station (TunerRadioBrowserClient* self,
                                                                       JsonNode* node);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda32_ (Block4Data* _data4_,
                  JsonArray* array,
                  guint index,
                  JsonNode* element);
static void ___lambda32__json_array_foreach (JsonArray* array,
                                      guint index_,
                                      JsonNode* element_node,
                                      gpointer self);
static TunerRadioBrowserTag* tuner_radio_browser_client_jnode_to_tag (TunerRadioBrowserClient* self,
                                                               JsonNode* node);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda63_ (Block5Data* _data5_,
                  JsonArray* array,
                  guint index,
                  JsonNode* element);
static void ___lambda63__json_array_foreach (JsonArray* array,
                                      guint index_,
                                      JsonNode* element_node,
                                      gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static GSrvTarget* _vala_GSrvTarget_copy (GSrvTarget* self);
static void _vala_GSrvTarget_free (GSrvTarget* self);
static void __vala_GSrvTarget_free0_ (gpointer var);
static inline void _g_list_free___vala_GSrvTarget_free0_ (GList* self);
static void ______lambda62_ (Block6Data* _data6_,
                      JsonArray* array,
                      guint index_,
                      JsonNode* element_node);
static void _______lambda62__json_array_foreach (JsonArray* array,
                                          guint index_,
                                          JsonNode* element_node,
                                          gpointer self);
static void tuner_radio_browser_client_finalize (GObject * obj);
static GType tuner_radio_browser_client_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
tuner_radio_browser_station_get_instance_private (TunerRadioBrowserStation* self)
{
	return G_STRUCT_MEMBER_P (self, TunerRadioBrowserStation_private_offset);
}

TunerRadioBrowserStation*
tuner_radio_browser_station_construct (GType object_type)
{
	TunerRadioBrowserStation * self = NULL;
	self = (TunerRadioBrowserStation*) g_object_new (object_type, NULL);
	return self;
}

TunerRadioBrowserStation*
tuner_radio_browser_station_new (void)
{
	return tuner_radio_browser_station_construct (TUNER_RADIO_BROWSER_TYPE_STATION);
}

const gchar*
tuner_radio_browser_station_get_stationuuid (TunerRadioBrowserStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stationuuid;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_station_set_stationuuid (TunerRadioBrowserStation* self,
                                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_stationuuid (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_stationuuid);
		self->priv->_stationuuid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_STATIONUUID_PROPERTY]);
	}
}

const gchar*
tuner_radio_browser_station_get_name (TunerRadioBrowserStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_station_set_name (TunerRadioBrowserStation* self,
                                      const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_NAME_PROPERTY]);
	}
}

const gchar*
tuner_radio_browser_station_get_url_resolved (TunerRadioBrowserStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_url_resolved;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_station_set_url_resolved (TunerRadioBrowserStation* self,
                                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_url_resolved (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_url_resolved);
		self->priv->_url_resolved = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_URL_RESOLVED_PROPERTY]);
	}
}

const gchar*
tuner_radio_browser_station_get_country (TunerRadioBrowserStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_country;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_station_set_country (TunerRadioBrowserStation* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_country (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_country);
		self->priv->_country = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_COUNTRY_PROPERTY]);
	}
}

const gchar*
tuner_radio_browser_station_get_countrycode (TunerRadioBrowserStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_countrycode;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_station_set_countrycode (TunerRadioBrowserStation* self,
                                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_countrycode (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_countrycode);
		self->priv->_countrycode = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_COUNTRYCODE_PROPERTY]);
	}
}

const gchar*
tuner_radio_browser_station_get_favicon (TunerRadioBrowserStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_favicon;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_station_set_favicon (TunerRadioBrowserStation* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_favicon (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_favicon);
		self->priv->_favicon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_FAVICON_PROPERTY]);
	}
}

guint
tuner_radio_browser_station_get_clickcount (TunerRadioBrowserStation* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_clickcount;
	return result;
}

void
tuner_radio_browser_station_set_clickcount (TunerRadioBrowserStation* self,
                                            guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_clickcount (self);
	if (old_value != value) {
		self->priv->_clickcount = value;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_CLICKCOUNT_PROPERTY]);
	}
}

const gchar*
tuner_radio_browser_station_get_homepage (TunerRadioBrowserStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_homepage;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_station_set_homepage (TunerRadioBrowserStation* self,
                                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_homepage (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_homepage);
		self->priv->_homepage = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_HOMEPAGE_PROPERTY]);
	}
}

const gchar*
tuner_radio_browser_station_get_codec (TunerRadioBrowserStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_codec;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_station_set_codec (TunerRadioBrowserStation* self,
                                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_codec (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_codec);
		self->priv->_codec = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_CODEC_PROPERTY]);
	}
}

gint
tuner_radio_browser_station_get_bitrate (TunerRadioBrowserStation* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_bitrate;
	return result;
}

void
tuner_radio_browser_station_set_bitrate (TunerRadioBrowserStation* self,
                                         gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_station_get_bitrate (self);
	if (old_value != value) {
		self->priv->_bitrate = value;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_BITRATE_PROPERTY]);
	}
}

static void
tuner_radio_browser_station_class_init (TunerRadioBrowserStationClass * klass,
                                        gpointer klass_data)
{
	tuner_radio_browser_station_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerRadioBrowserStation_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_radio_browser_station_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_radio_browser_station_set_property;
	G_OBJECT_CLASS (klass)->finalize = tuner_radio_browser_station_finalize;
	/** @brief Unique identifier for the station */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_STATIONUUID_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_STATIONUUID_PROPERTY] = g_param_spec_string ("stationuuid", "stationuuid", "stationuuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Name of the station */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_NAME_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Resolved URL of the station's stream */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_URL_RESOLVED_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_URL_RESOLVED_PROPERTY] = g_param_spec_string ("url-resolved", "url-resolved", "url-resolved", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Country where the station is located */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_COUNTRY_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_COUNTRY_PROPERTY] = g_param_spec_string ("country", "country", "country", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Country code of the station's location */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_COUNTRYCODE_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_COUNTRYCODE_PROPERTY] = g_param_spec_string ("countrycode", "countrycode", "countrycode", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief URL of the station's favicon */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_FAVICON_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_FAVICON_PROPERTY] = g_param_spec_string ("favicon", "favicon", "favicon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Number of clicks/listens for the station */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_CLICKCOUNT_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_CLICKCOUNT_PROPERTY] = g_param_spec_uint ("clickcount", "clickcount", "clickcount", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief URL of the station's homepage */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_HOMEPAGE_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_HOMEPAGE_PROPERTY] = g_param_spec_string ("homepage", "homepage", "homepage", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Audio codec used by the station */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_CODEC_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_CODEC_PROPERTY] = g_param_spec_string ("codec", "codec", "codec", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Bitrate of the station's stream */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_STATION_BITRATE_PROPERTY, tuner_radio_browser_station_properties[TUNER_RADIO_BROWSER_STATION_BITRATE_PROPERTY] = g_param_spec_int ("bitrate", "bitrate", "bitrate", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
tuner_radio_browser_station_instance_init (TunerRadioBrowserStation * self,
                                           gpointer klass)
{
	self->priv = tuner_radio_browser_station_get_instance_private (self);
}

static void
tuner_radio_browser_station_finalize (GObject * obj)
{
	TunerRadioBrowserStation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_RADIO_BROWSER_TYPE_STATION, TunerRadioBrowserStation);
	_g_free0 (self->priv->_stationuuid);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_url_resolved);
	_g_free0 (self->priv->_country);
	_g_free0 (self->priv->_countrycode);
	_g_free0 (self->priv->_favicon);
	_g_free0 (self->priv->_homepage);
	_g_free0 (self->priv->_codec);
	G_OBJECT_CLASS (tuner_radio_browser_station_parent_class)->finalize (obj);
}

/**
     * @class Station
     * @brief Station data subset returned from radio-browser API
     *
     * This class represents a radio station with its properties as returned by the radio-browser API.
     */
static GType
tuner_radio_browser_station_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerRadioBrowserStationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_radio_browser_station_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerRadioBrowserStation), 0, (GInstanceInitFunc) tuner_radio_browser_station_instance_init, NULL };
	GType tuner_radio_browser_station_type_id;
	tuner_radio_browser_station_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerRadioBrowserStation", &g_define_type_info, 0);
	TunerRadioBrowserStation_private_offset = g_type_add_instance_private (tuner_radio_browser_station_type_id, sizeof (TunerRadioBrowserStationPrivate));
	return tuner_radio_browser_station_type_id;
}

GType
tuner_radio_browser_station_get_type (void)
{
	static volatile gsize tuner_radio_browser_station_type_id__once = 0;
	if (g_once_init_enter (&tuner_radio_browser_station_type_id__once)) {
		GType tuner_radio_browser_station_type_id;
		tuner_radio_browser_station_type_id = tuner_radio_browser_station_get_type_once ();
		g_once_init_leave (&tuner_radio_browser_station_type_id__once, tuner_radio_browser_station_type_id);
	}
	return tuner_radio_browser_station_type_id__once;
}

static void
_vala_tuner_radio_browser_station_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	TunerRadioBrowserStation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_RADIO_BROWSER_TYPE_STATION, TunerRadioBrowserStation);
	switch (property_id) {
		case TUNER_RADIO_BROWSER_STATION_STATIONUUID_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_station_get_stationuuid (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_NAME_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_station_get_name (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_URL_RESOLVED_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_station_get_url_resolved (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_COUNTRY_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_station_get_country (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_COUNTRYCODE_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_station_get_countrycode (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_FAVICON_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_station_get_favicon (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_CLICKCOUNT_PROPERTY:
		g_value_set_uint (value, tuner_radio_browser_station_get_clickcount (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_HOMEPAGE_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_station_get_homepage (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_CODEC_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_station_get_codec (self));
		break;
		case TUNER_RADIO_BROWSER_STATION_BITRATE_PROPERTY:
		g_value_set_int (value, tuner_radio_browser_station_get_bitrate (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_radio_browser_station_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	TunerRadioBrowserStation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_RADIO_BROWSER_TYPE_STATION, TunerRadioBrowserStation);
	switch (property_id) {
		case TUNER_RADIO_BROWSER_STATION_STATIONUUID_PROPERTY:
		tuner_radio_browser_station_set_stationuuid (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_NAME_PROPERTY:
		tuner_radio_browser_station_set_name (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_URL_RESOLVED_PROPERTY:
		tuner_radio_browser_station_set_url_resolved (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_COUNTRY_PROPERTY:
		tuner_radio_browser_station_set_country (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_COUNTRYCODE_PROPERTY:
		tuner_radio_browser_station_set_countrycode (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_FAVICON_PROPERTY:
		tuner_radio_browser_station_set_favicon (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_CLICKCOUNT_PROPERTY:
		tuner_radio_browser_station_set_clickcount (self, g_value_get_uint (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_HOMEPAGE_PROPERTY:
		tuner_radio_browser_station_set_homepage (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_CODEC_PROPERTY:
		tuner_radio_browser_station_set_codec (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_STATION_BITRATE_PROPERTY:
		tuner_radio_browser_station_set_bitrate (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
tuner_radio_browser_search_params_copy (const TunerRadioBrowserSearchParams* self,
                                        TunerRadioBrowserSearchParams* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	_tmp0_ = (*self).text;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).text);
	(*dest).text = _tmp1_;
	_tmp2_ = (*self).tags;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 ((*dest).tags);
	(*dest).tags = _tmp3_;
	_tmp4_ = (*self).uuids;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 ((*dest).uuids);
	(*dest).uuids = _tmp5_;
	_tmp6_ = (*self).countrycode;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).countrycode);
	(*dest).countrycode = _tmp7_;
	(*dest).order = (*self).order;
	(*dest).reverse = (*self).reverse;
}

void
tuner_radio_browser_search_params_destroy (TunerRadioBrowserSearchParams* self)
{
	_g_free0 ((*self).text);
	_g_object_unref0 ((*self).tags);
	_g_object_unref0 ((*self).uuids);
	_g_free0 ((*self).countrycode);
}

TunerRadioBrowserSearchParams*
tuner_radio_browser_search_params_dup (const TunerRadioBrowserSearchParams* self)
{
	TunerRadioBrowserSearchParams* dup;
	dup = g_new0 (TunerRadioBrowserSearchParams, 1);
	tuner_radio_browser_search_params_copy (self, dup);
	return dup;
}

void
tuner_radio_browser_search_params_free (TunerRadioBrowserSearchParams* self)
{
	tuner_radio_browser_search_params_destroy (self);
	g_free (self);
}

static GType
tuner_radio_browser_search_params_get_type_once (void)
{
	GType tuner_radio_browser_search_params_type_id;
	tuner_radio_browser_search_params_type_id = g_boxed_type_register_static ("TunerRadioBrowserSearchParams", (GBoxedCopyFunc) tuner_radio_browser_search_params_dup, (GBoxedFreeFunc) tuner_radio_browser_search_params_free);
	return tuner_radio_browser_search_params_type_id;
}

GType
tuner_radio_browser_search_params_get_type (void)
{
	static volatile gsize tuner_radio_browser_search_params_type_id__once = 0;
	if (g_once_init_enter (&tuner_radio_browser_search_params_type_id__once)) {
		GType tuner_radio_browser_search_params_type_id;
		tuner_radio_browser_search_params_type_id = tuner_radio_browser_search_params_get_type_once ();
		g_once_init_leave (&tuner_radio_browser_search_params_type_id__once, tuner_radio_browser_search_params_type_id);
	}
	return tuner_radio_browser_search_params_type_id__once;
}

GQuark
tuner_radio_browser_data_error_quark (void)
{
	return g_quark_from_static_string ("tuner-radio-browser-data-error-quark");
}

static GType
tuner_radio_browser_data_error_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_RADIO_BROWSER_DATA_ERROR_PARSE_DATA, "TUNER_RADIO_BROWSER_DATA_ERROR_PARSE_DATA", "parse-data"}, {TUNER_RADIO_BROWSER_DATA_ERROR_NO_CONNECTION, "TUNER_RADIO_BROWSER_DATA_ERROR_NO_CONNECTION", "no-connection"}, {0, NULL, NULL}};
	GType tuner_radio_browser_data_error_type_id;
	tuner_radio_browser_data_error_type_id = g_enum_register_static ("TunerRadioBrowserDataError", values);
	return tuner_radio_browser_data_error_type_id;
}

GType
tuner_radio_browser_data_error_get_type (void)
{
	static volatile gsize tuner_radio_browser_data_error_type_id__once = 0;
	if (g_once_init_enter (&tuner_radio_browser_data_error_type_id__once)) {
		GType tuner_radio_browser_data_error_type_id;
		tuner_radio_browser_data_error_type_id = tuner_radio_browser_data_error_get_type_once ();
		g_once_init_leave (&tuner_radio_browser_data_error_type_id__once, tuner_radio_browser_data_error_type_id);
	}
	return tuner_radio_browser_data_error_type_id__once;
}

/**
     * @enum SortOrder
     * @brief Enumeration of sorting options for station search results
     */
/**
         * @brief Convert SortOrder enum to string representation
         * @return String representation of the SortOrder
         */
gchar*
tuner_radio_browser_sort_order_to_string (TunerRadioBrowserSortOrder self)
{
	gchar* result;
	switch (self) {
		case TUNER_RADIO_BROWSER_SORT_ORDER_NAME:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("name");
			result = _tmp0_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_URL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("url");
			result = _tmp1_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_HOMEPAGE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("homepage");
			result = _tmp2_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_FAVICON:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("favicon");
			result = _tmp3_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_TAGS:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("tags");
			result = _tmp4_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_COUNTRY:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("country");
			result = _tmp5_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_STATE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("state");
			result = _tmp6_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_LANGUAGE:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("language");
			result = _tmp7_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_VOTES:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("votes");
			result = _tmp8_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_CODEC:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("codec");
			result = _tmp9_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_BITRATE:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup ("bitrate");
			result = _tmp10_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_LASTCHECKOK:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup ("lastcheckok");
			result = _tmp11_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_LASTCHECKTIME:
		{
			gchar* _tmp12_;
			_tmp12_ = g_strdup ("lastchecktime");
			result = _tmp12_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_CLICKTIMESTAMP:
		{
			gchar* _tmp13_;
			_tmp13_ = g_strdup ("clicktimestamp");
			result = _tmp13_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_CLICKCOUNT:
		{
			gchar* _tmp14_;
			_tmp14_ = g_strdup ("clickcount");
			result = _tmp14_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_CLICKTREND:
		{
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("clicktrend");
			result = _tmp15_;
			return result;
		}
		case TUNER_RADIO_BROWSER_SORT_ORDER_RANDOM:
		{
			gchar* _tmp16_;
			_tmp16_ = g_strdup ("random");
			result = _tmp16_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
tuner_radio_browser_sort_order_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_RADIO_BROWSER_SORT_ORDER_NAME, "TUNER_RADIO_BROWSER_SORT_ORDER_NAME", "name"}, {TUNER_RADIO_BROWSER_SORT_ORDER_URL, "TUNER_RADIO_BROWSER_SORT_ORDER_URL", "url"}, {TUNER_RADIO_BROWSER_SORT_ORDER_HOMEPAGE, "TUNER_RADIO_BROWSER_SORT_ORDER_HOMEPAGE", "homepage"}, {TUNER_RADIO_BROWSER_SORT_ORDER_FAVICON, "TUNER_RADIO_BROWSER_SORT_ORDER_FAVICON", "favicon"}, {TUNER_RADIO_BROWSER_SORT_ORDER_TAGS, "TUNER_RADIO_BROWSER_SORT_ORDER_TAGS", "tags"}, {TUNER_RADIO_BROWSER_SORT_ORDER_COUNTRY, "TUNER_RADIO_BROWSER_SORT_ORDER_COUNTRY", "country"}, {TUNER_RADIO_BROWSER_SORT_ORDER_STATE, "TUNER_RADIO_BROWSER_SORT_ORDER_STATE", "state"}, {TUNER_RADIO_BROWSER_SORT_ORDER_LANGUAGE, "TUNER_RADIO_BROWSER_SORT_ORDER_LANGUAGE", "language"}, {TUNER_RADIO_BROWSER_SORT_ORDER_VOTES, "TUNER_RADIO_BROWSER_SORT_ORDER_VOTES", "votes"}, {TUNER_RADIO_BROWSER_SORT_ORDER_CODEC, "TUNER_RADIO_BROWSER_SORT_ORDER_CODEC", "codec"}, {TUNER_RADIO_BROWSER_SORT_ORDER_BITRATE, "TUNER_RADIO_BROWSER_SORT_ORDER_BITRATE", "bitrate"}, {TUNER_RADIO_BROWSER_SORT_ORDER_LASTCHECKOK, "TUNER_RADIO_BROWSER_SORT_ORDER_LASTCHECKOK", "lastcheckok"}, {TUNER_RADIO_BROWSER_SORT_ORDER_LASTCHECKTIME, "TUNER_RADIO_BROWSER_SORT_ORDER_LASTCHECKTIME", "lastchecktime"}, {TUNER_RADIO_BROWSER_SORT_ORDER_CLICKTIMESTAMP, "TUNER_RADIO_BROWSER_SORT_ORDER_CLICKTIMESTAMP", "clicktimestamp"}, {TUNER_RADIO_BROWSER_SORT_ORDER_CLICKCOUNT, "TUNER_RADIO_BROWSER_SORT_ORDER_CLICKCOUNT", "clickcount"}, {TUNER_RADIO_BROWSER_SORT_ORDER_CLICKTREND, "TUNER_RADIO_BROWSER_SORT_ORDER_CLICKTREND", "clicktrend"}, {TUNER_RADIO_BROWSER_SORT_ORDER_RANDOM, "TUNER_RADIO_BROWSER_SORT_ORDER_RANDOM", "random"}, {0, NULL, NULL}};
	GType tuner_radio_browser_sort_order_type_id;
	tuner_radio_browser_sort_order_type_id = g_enum_register_static ("TunerRadioBrowserSortOrder", values);
	return tuner_radio_browser_sort_order_type_id;
}

GType
tuner_radio_browser_sort_order_get_type (void)
{
	static volatile gsize tuner_radio_browser_sort_order_type_id__once = 0;
	if (g_once_init_enter (&tuner_radio_browser_sort_order_type_id__once)) {
		GType tuner_radio_browser_sort_order_type_id;
		tuner_radio_browser_sort_order_type_id = tuner_radio_browser_sort_order_get_type_once ();
		g_once_init_leave (&tuner_radio_browser_sort_order_type_id__once, tuner_radio_browser_sort_order_type_id);
	}
	return tuner_radio_browser_sort_order_type_id__once;
}

static inline gpointer
tuner_radio_browser_tag_get_instance_private (TunerRadioBrowserTag* self)
{
	return G_STRUCT_MEMBER_P (self, TunerRadioBrowserTag_private_offset);
}

TunerRadioBrowserTag*
tuner_radio_browser_tag_construct (GType object_type)
{
	TunerRadioBrowserTag * self = NULL;
	self = (TunerRadioBrowserTag*) g_object_new (object_type, NULL);
	return self;
}

TunerRadioBrowserTag*
tuner_radio_browser_tag_new (void)
{
	return tuner_radio_browser_tag_construct (TUNER_RADIO_BROWSER_TYPE_TAG);
}

const gchar*
tuner_radio_browser_tag_get_name (TunerRadioBrowserTag* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
tuner_radio_browser_tag_set_name (TunerRadioBrowserTag* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_tag_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_tag_properties[TUNER_RADIO_BROWSER_TAG_NAME_PROPERTY]);
	}
}

guint
tuner_radio_browser_tag_get_stationcount (TunerRadioBrowserTag* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_stationcount;
	return result;
}

void
tuner_radio_browser_tag_set_stationcount (TunerRadioBrowserTag* self,
                                          guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_radio_browser_tag_get_stationcount (self);
	if (old_value != value) {
		self->priv->_stationcount = value;
		g_object_notify_by_pspec ((GObject *) self, tuner_radio_browser_tag_properties[TUNER_RADIO_BROWSER_TAG_STATIONCOUNT_PROPERTY]);
	}
}

static void
tuner_radio_browser_tag_class_init (TunerRadioBrowserTagClass * klass,
                                    gpointer klass_data)
{
	tuner_radio_browser_tag_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerRadioBrowserTag_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_radio_browser_tag_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_radio_browser_tag_set_property;
	G_OBJECT_CLASS (klass)->finalize = tuner_radio_browser_tag_finalize;
	/** @brief Name of the tag */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_TAG_NAME_PROPERTY, tuner_radio_browser_tag_properties[TUNER_RADIO_BROWSER_TAG_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Number of stations associated with this tag */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_RADIO_BROWSER_TAG_STATIONCOUNT_PROPERTY, tuner_radio_browser_tag_properties[TUNER_RADIO_BROWSER_TAG_STATIONCOUNT_PROPERTY] = g_param_spec_uint ("stationcount", "stationcount", "stationcount", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
tuner_radio_browser_tag_instance_init (TunerRadioBrowserTag * self,
                                       gpointer klass)
{
	self->priv = tuner_radio_browser_tag_get_instance_private (self);
}

static void
tuner_radio_browser_tag_finalize (GObject * obj)
{
	TunerRadioBrowserTag * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_RADIO_BROWSER_TYPE_TAG, TunerRadioBrowserTag);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (tuner_radio_browser_tag_parent_class)->finalize (obj);
}

/**
     * @class Tag
     * @brief Represents a tag associated with radio stations
     */
static GType
tuner_radio_browser_tag_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerRadioBrowserTagClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_radio_browser_tag_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerRadioBrowserTag), 0, (GInstanceInitFunc) tuner_radio_browser_tag_instance_init, NULL };
	GType tuner_radio_browser_tag_type_id;
	tuner_radio_browser_tag_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerRadioBrowserTag", &g_define_type_info, 0);
	TunerRadioBrowserTag_private_offset = g_type_add_instance_private (tuner_radio_browser_tag_type_id, sizeof (TunerRadioBrowserTagPrivate));
	return tuner_radio_browser_tag_type_id;
}

GType
tuner_radio_browser_tag_get_type (void)
{
	static volatile gsize tuner_radio_browser_tag_type_id__once = 0;
	if (g_once_init_enter (&tuner_radio_browser_tag_type_id__once)) {
		GType tuner_radio_browser_tag_type_id;
		tuner_radio_browser_tag_type_id = tuner_radio_browser_tag_get_type_once ();
		g_once_init_leave (&tuner_radio_browser_tag_type_id__once, tuner_radio_browser_tag_type_id);
	}
	return tuner_radio_browser_tag_type_id__once;
}

static void
_vala_tuner_radio_browser_tag_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	TunerRadioBrowserTag * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_RADIO_BROWSER_TYPE_TAG, TunerRadioBrowserTag);
	switch (property_id) {
		case TUNER_RADIO_BROWSER_TAG_NAME_PROPERTY:
		g_value_set_string (value, tuner_radio_browser_tag_get_name (self));
		break;
		case TUNER_RADIO_BROWSER_TAG_STATIONCOUNT_PROPERTY:
		g_value_set_uint (value, tuner_radio_browser_tag_get_stationcount (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_radio_browser_tag_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	TunerRadioBrowserTag * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_RADIO_BROWSER_TYPE_TAG, TunerRadioBrowserTag);
	switch (property_id) {
		case TUNER_RADIO_BROWSER_TAG_NAME_PROPERTY:
		tuner_radio_browser_tag_set_name (self, g_value_get_string (value));
		break;
		case TUNER_RADIO_BROWSER_TAG_STATIONCOUNT_PROPERTY:
		tuner_radio_browser_tag_set_stationcount (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

/**
     * @brief Compare two strings for equality
     * @param a First string to compare
     * @param b Second string to compare
     * @return True if strings are equal, false otherwise
     */
gboolean
tuner_radio_browser_EqualCompareString (const gchar* a,
                                        const gchar* b)
{
	gboolean result;
	g_return_val_if_fail (a != NULL, FALSE);
	g_return_val_if_fail (b != NULL, FALSE);
	result = g_strcmp0 (a, b) == 0;
	return result;
}

static inline gpointer
tuner_radio_browser_client_get_instance_private (TunerRadioBrowserClient* self)
{
	return G_STRUCT_MEMBER_P (self, TunerRadioBrowserClient_private_offset);
}

/**
         * @brief Constructor for RadioBrowser Client
         * @throw DataError if unable to initialize the client
         */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

TunerRadioBrowserClient*
tuner_radio_browser_client_construct (GType object_type,
                                      GError** error)
{
	TunerRadioBrowserClient * self = NULL;
	GeeArrayList* servers = NULL;
	gchar* _servers = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeArrayList* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint32 chosen_server = 0;
	GeeArrayList* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GeeArrayList* _tmp17_;
	gpointer _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GError* _inner_error0_ = NULL;
	self = (TunerRadioBrowserClient*) g_object_new (object_type, NULL);
	_tmp0_ = g_getenv ("TUNER_API");
	_tmp1_ = g_strdup (_tmp0_);
	_servers = _tmp1_;
	_tmp2_ = _servers;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		GeeArrayList* _tmp6_;
		_tmp3_ = _servers;
		_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, ":", 0);
		_tmp6_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp5_, _vala_array_length (_tmp4_), NULL, NULL, NULL);
		_g_object_unref0 (servers);
		servers = _tmp6_;
	} else {
		GeeArrayList* _tmp7_ = NULL;
		GeeArrayList* _tmp8_;
		GeeArrayList* _tmp9_;
		_tmp8_ = tuner_radio_browser_client_get_api_servers (self, &_inner_error0_);
		_tmp7_ = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (_servers);
				_g_object_unref0 (servers);
				_g_object_unref0 (self);
				return NULL;
			} else {
				_g_free0 (_servers);
				_g_object_unref0 (servers);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp9_ = _tmp7_;
		_tmp7_ = NULL;
		_g_object_unref0 (servers);
		servers = _tmp9_;
		_g_object_unref0 (_tmp7_);
	}
	_tmp10_ = servers;
	_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
	_tmp12_ = _tmp11_;
	if (_tmp12_ == 0) {
		GError* _tmp13_;
		_tmp13_ = g_error_new_literal (TUNER_RADIO_BROWSER_DATA_ERROR, TUNER_RADIO_BROWSER_DATA_ERROR_NO_CONNECTION, "Unable to resolve API servers for radio-browser.info");
		_inner_error0_ = _tmp13_;
		if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (_servers);
			_g_object_unref0 (servers);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_g_free0 (_servers);
			_g_object_unref0 (servers);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp14_ = servers;
	_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
	_tmp16_ = _tmp15_;
	chosen_server = g_random_int_range ((gint32) 0, (gint32) _tmp16_);
	_tmp17_ = servers;
	_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, (gint) chosen_server);
	_tmp19_ = (gchar*) _tmp18_;
	_tmp20_ = string_to_string (_tmp19_);
	_tmp21_ = g_strconcat ("https://", _tmp20_, NULL);
	_g_free0 (self->priv->current_server);
	self->priv->current_server = _tmp21_;
	_g_free0 (_tmp19_);
	_tmp22_ = self->priv->current_server;
	_tmp23_ = string_to_string (_tmp22_);
	_tmp24_ = g_strconcat ("RadioBrowser Client - Chosen radio-browser.info server: ", _tmp23_, NULL);
	_tmp25_ = _tmp24_;
	g_debug ("RadioBrowser.vala:205: %s", _tmp25_);
	_g_free0 (_tmp25_);
	_g_free0 (_servers);
	_g_object_unref0 (servers);
	return self;
}

TunerRadioBrowserClient*
tuner_radio_browser_client_new (GError** error)
{
	return tuner_radio_browser_client_construct (TUNER_RADIO_BROWSER_TYPE_CLIENT, error);
}

/**
         * @brief Track a station listen event
         * @param stationuuid UUID of the station being listened to
         */
void
tuner_radio_browser_client_track (TunerRadioBrowserClient* self,
                                  const gchar* stationuuid)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint status_code = 0U;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	guint _tmp8_ = 0U;
	GInputStream* _tmp9_;
	GInputStream* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (stationuuid != NULL);
	_tmp0_ = string_to_string (stationuuid);
	_tmp1_ = g_strconcat ("sending listening event for station ", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	g_debug ("RadioBrowser.vala:213: %s", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->current_server;
	_tmp4_ = string_to_string (_tmp3_);
	_tmp5_ = string_to_string (stationuuid);
	_tmp6_ = g_strconcat (_tmp4_, "/json/url/", _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	_tmp9_ = tuner_http_client_GET (_tmp7_, &_tmp8_);
	status_code = _tmp8_;
	_tmp10_ = _tmp9_;
	_g_object_unref0 (_tmp10_);
	_g_free0 (_tmp7_);
	_tmp11_ = g_strdup_printf ("%u", status_code);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat ("response: ", _tmp12_, NULL);
	_tmp14_ = _tmp13_;
	g_debug ("RadioBrowser.vala:216: %s", _tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
}

/**
         * @brief Vote for a station
         * @param stationuuid UUID of the station being voted for
         */
void
tuner_radio_browser_client_vote (TunerRadioBrowserClient* self,
                                 const gchar* stationuuid)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint status_code = 0U;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	guint _tmp8_ = 0U;
	GInputStream* _tmp9_;
	GInputStream* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (stationuuid != NULL);
	_tmp0_ = string_to_string (stationuuid);
	_tmp1_ = g_strconcat ("sending vote event for station ", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	g_debug ("RadioBrowser.vala:224: %s", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->current_server;
	_tmp4_ = string_to_string (_tmp3_);
	_tmp5_ = string_to_string (stationuuid);
	_tmp6_ = g_strconcat (_tmp4_, "/json/vote/", _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	_tmp9_ = tuner_http_client_GET (_tmp7_, &_tmp8_);
	status_code = _tmp8_;
	_tmp10_ = _tmp9_;
	_g_object_unref0 (_tmp10_);
	_g_free0 (_tmp7_);
	_tmp11_ = g_strdup_printf ("%u", status_code);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat ("response: ", _tmp12_, NULL);
	_tmp14_ = _tmp13_;
	g_debug ("RadioBrowser.vala:227: %s", _tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
}

/**
         * @brief Get stations from a specific API resource
         * @param resource API resource path
         * @return ArrayList of Station objects
         * @throw DataError if unable to retrieve or parse station data
         */
static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static gpointer
_json_array_ref0 (gpointer self)
{
	return self ? json_array_ref (self) : NULL;
}

GeeArrayList*
tuner_radio_browser_client_get_stations (TunerRadioBrowserClient* self,
                                         const gchar* resource,
                                         GError** error)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	JsonNode* rootnode = NULL;
	GeeArrayList* _tmp37_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (resource != NULL, NULL);
	_tmp0_ = string_to_string (resource);
	_tmp1_ = g_strconcat ("RB ", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	g_debug ("RadioBrowser.vala:237: %s", _tmp2_);
	_g_free0 (_tmp2_);
	{
		guint status_code = 0U;
		GInputStream* response = NULL;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		guint _tmp8_ = 0U;
		GInputStream* _tmp9_;
		GInputStream* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		JsonArray* rootarray = NULL;
		JsonArray* _tmp28_;
		JsonArray* _tmp29_;
		GeeArrayList* stations = NULL;
		JsonArray* _tmp30_;
		GeeArrayList* _tmp31_;
		g_debug ("RadioBrowser.vala:244: %s", "Requesting from 'radio-browser.info'");
		_tmp3_ = self->priv->current_server;
		_tmp4_ = string_to_string (_tmp3_);
		_tmp5_ = string_to_string (resource);
		_tmp6_ = g_strconcat (_tmp4_, "/", _tmp5_, NULL);
		_tmp7_ = _tmp6_;
		_tmp9_ = tuner_http_client_GET (_tmp7_, &_tmp8_);
		status_code = _tmp8_;
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp7_);
		response = _tmp10_;
		_tmp11_ = g_strdup_printf ("%u", status_code);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strconcat ("Response from 'radio-browser.info': ", _tmp12_, NULL);
		_tmp14_ = _tmp13_;
		g_debug ("RadioBrowser.vala:246: %s", _tmp14_);
		_g_free0 (_tmp14_);
		_g_free0 (_tmp12_);
		{
			JsonParser* parser = NULL;
			JsonParser* _tmp15_;
			JsonParser* _tmp16_;
			GInputStream* _tmp17_;
			JsonParser* _tmp18_;
			JsonNode* _tmp19_;
			JsonNode* _tmp20_;
			_tmp15_ = json_parser_new ();
			parser = _tmp15_;
			_tmp16_ = parser;
			_tmp17_ = response;
			json_parser_load_from_stream (_tmp16_, _tmp17_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (parser);
				goto __catch1_g_error;
			}
			_tmp18_ = parser;
			_tmp19_ = json_parser_get_root (_tmp18_);
			_tmp20_ = __vala_JsonNode_copy0 (_tmp19_);
			__vala_JsonNode_free0 (rootnode);
			rootnode = _tmp20_;
			_g_object_unref0 (parser);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			GError* _tmp26_;
			GError* _tmp27_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp21_ = e;
			_tmp22_ = _tmp21_->message;
			_tmp23_ = string_to_string (_tmp22_);
			_tmp24_ = g_strconcat ("Unable to parse JSON response: ", _tmp23_, NULL);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_error_new_literal (TUNER_RADIO_BROWSER_DATA_ERROR, TUNER_RADIO_BROWSER_DATA_ERROR_PARSE_DATA, _tmp25_);
			_tmp27_ = _tmp26_;
			_g_free0 (_tmp25_);
			_inner_error0_ = _tmp27_;
			_g_error_free0 (e);
			goto __finally1;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (response);
			goto __catch0_g_error;
		}
		_tmp28_ = json_node_get_array (rootnode);
		_tmp29_ = _json_array_ref0 (_tmp28_);
		rootarray = _tmp29_;
		_tmp30_ = rootarray;
		_tmp31_ = tuner_radio_browser_client_jarray_to_stations (self, _tmp30_);
		stations = _tmp31_;
		result = stations;
		_json_array_unref0 (rootarray);
		_g_object_unref0 (response);
		__vala_JsonNode_free0 (rootnode);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp32_ = e;
		_tmp33_ = _tmp32_->message;
		_tmp34_ = string_to_string (_tmp33_);
		_tmp35_ = g_strconcat ("Error retrieving stations: ", _tmp34_, NULL);
		_tmp36_ = _tmp35_;
		g_warning ("RadioBrowser.vala:260: %s", _tmp36_);
		_g_free0 (_tmp36_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			__vala_JsonNode_free0 (rootnode);
			return NULL;
		} else {
			__vala_JsonNode_free0 (rootnode);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp37_ = gee_array_list_new (TUNER_RADIO_BROWSER_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	result = _tmp37_;
	__vala_JsonNode_free0 (rootnode);
	return result;
}

/**
         * @brief Search for stations based on given parameters
         * @param params Search parameters
         * @param rowcount Maximum number of results to return
         * @param offset Offset for pagination
         * @return ArrayList of Station objects matching the search criteria
         * @throw DataError if unable to retrieve or parse station data
         */
static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp20_ = str_array[0];
		if (_tmp20_ != NULL) {
			const gchar* _tmp21_;
			_tmp21_ = str_array[0];
			_tmp19_ = (const gchar*) _tmp21_;
		} else {
			_tmp19_ = "";
		}
		_tmp22_ = res;
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
		ptr = _tmp23_;
		{
			gboolean _tmp24_ = FALSE;
			i = 1;
			_tmp24_ = TRUE;
			while (TRUE) {
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
				if (!_tmp24_) {
					gint _tmp25_;
					_tmp25_ = i;
					i = _tmp25_ + 1;
				}
				_tmp24_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp26_ = ptr;
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
				ptr = _tmp27_;
				_tmp29_ = str_array[i];
				if (_tmp29_ != NULL) {
					const gchar* _tmp30_;
					_tmp30_ = str_array[i];
					_tmp28_ = (const gchar*) _tmp30_;
				} else {
					_tmp28_ = "";
				}
				_tmp31_ = ptr;
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
				ptr = _tmp32_;
			}
		}
		_tmp33_ = res;
		res = NULL;
		result = (gchar*) _tmp33_;
		return result;
	} else {
		gchar* _tmp34_;
		_tmp34_ = g_strdup ("");
		result = _tmp34_;
		return result;
	}
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

GeeArrayList*
tuner_radio_browser_client_search (TunerRadioBrowserClient* self,
                                   TunerRadioBrowserSearchParams* params,
                                   guint rowcount,
                                   guint offset,
                                   GError** error)
{
	TunerRadioBrowserSearchParams _tmp0_;
	GeeArrayList* _tmp1_;
	gchar* resource = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_;
	TunerRadioBrowserSearchParams _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	TunerRadioBrowserSearchParams _tmp30_;
	const gchar* _tmp31_;
	TunerRadioBrowserSearchParams _tmp39_;
	GeeArrayList* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	TunerRadioBrowserSearchParams _tmp62_;
	const gchar* _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	TunerRadioBrowserSearchParams _tmp73_;
	GeeArrayList* _tmp81_ = NULL;
	const gchar* _tmp82_;
	GeeArrayList* _tmp83_;
	GeeArrayList* _tmp84_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (params != NULL, NULL);
	_tmp0_ = *params;
	_tmp1_ = _tmp0_.uuids;
	if (_tmp1_ != NULL) {
		GeeArrayList* stations = NULL;
		GeeArrayList* _tmp2_;
		_tmp2_ = gee_array_list_new (TUNER_RADIO_BROWSER_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		stations = _tmp2_;
		{
			GeeArrayList* _uuid_list = NULL;
			TunerRadioBrowserSearchParams _tmp3_;
			GeeArrayList* _tmp4_;
			gint _uuid_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _uuid_index = 0;
			_tmp3_ = *params;
			_tmp4_ = _tmp3_.uuids;
			_uuid_list = _tmp4_;
			_tmp5_ = _uuid_list;
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_uuid_size = _tmp7_;
			_uuid_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				gchar* uuid = NULL;
				GeeArrayList* _tmp10_;
				gpointer _tmp11_;
				TunerRadioBrowserStation* station = NULL;
				const gchar* _tmp12_;
				TunerRadioBrowserStation* _tmp13_;
				TunerRadioBrowserStation* _tmp14_;
				_uuid_index = _uuid_index + 1;
				_tmp8_ = _uuid_index;
				_tmp9_ = _uuid_size;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = _uuid_list;
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _uuid_index);
				uuid = (gchar*) _tmp11_;
				_tmp12_ = uuid;
				_tmp13_ = tuner_radio_browser_client_by_uuid (self, _tmp12_, &_inner_error0_);
				station = _tmp13_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (uuid);
						_g_object_unref0 (stations);
						return NULL;
					} else {
						_g_free0 (uuid);
						_g_object_unref0 (stations);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp14_ = station;
				if (_tmp14_ != NULL) {
					GeeArrayList* _tmp15_;
					TunerRadioBrowserStation* _tmp16_;
					_tmp15_ = stations;
					_tmp16_ = station;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
				}
				_g_object_unref0 (station);
				_g_free0 (uuid);
			}
		}
		result = stations;
		return result;
	}
	_tmp17_ = g_strdup_printf ("%u", rowcount);
	_tmp18_ = _tmp17_;
	_tmp19_ = *params;
	_tmp20_ = tuner_radio_browser_sort_order_to_string (_tmp19_.order);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_strdup_printf ("%u", offset);
	_tmp23_ = _tmp22_;
	_tmp24_ = g_strconcat ("json/stations/search?limit=", _tmp18_, "&order=", _tmp21_, "&offset=", _tmp23_, NULL);
	_tmp25_ = _tmp24_;
	_g_free0 (_tmp23_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp18_);
	resource = _tmp25_;
	_tmp26_ = resource;
	_tmp27_ = string_to_string (_tmp26_);
	_tmp28_ = g_strconcat ("Search: ", _tmp27_, NULL);
	_tmp29_ = _tmp28_;
	g_debug ("RadioBrowser.vala:292: %s", _tmp29_);
	_g_free0 (_tmp29_);
	_tmp30_ = *params;
	_tmp31_ = _tmp30_.text;
	if (g_strcmp0 (_tmp31_, "") != 0) {
		const gchar* _tmp32_;
		TunerRadioBrowserSearchParams _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		_tmp32_ = resource;
		_tmp33_ = *params;
		_tmp34_ = _tmp33_.text;
		_tmp35_ = string_to_string (_tmp34_);
		_tmp36_ = g_strconcat ("&name=", _tmp35_, NULL);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_strconcat (_tmp32_, _tmp37_, NULL);
		_g_free0 (resource);
		resource = _tmp38_;
		_g_free0 (_tmp37_);
	}
	_tmp39_ = *params;
	_tmp40_ = _tmp39_.tags;
	_tmp41_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp40_);
	_tmp42_ = _tmp41_;
	if (_tmp42_ > 0) {
		gchar* tag_list = NULL;
		TunerRadioBrowserSearchParams _tmp43_;
		GeeArrayList* _tmp44_;
		gpointer _tmp45_;
		TunerRadioBrowserSearchParams _tmp46_;
		GeeArrayList* _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		const gchar* _tmp56_;
		const gchar* _tmp57_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		_tmp43_ = *params;
		_tmp44_ = _tmp43_.tags;
		_tmp45_ = gee_abstract_list_get ((GeeAbstractList*) _tmp44_, 0);
		tag_list = (gchar*) _tmp45_;
		_tmp46_ = *params;
		_tmp47_ = _tmp46_.tags;
		_tmp48_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp47_);
		_tmp49_ = _tmp48_;
		if (_tmp49_ > 1) {
			TunerRadioBrowserSearchParams _tmp50_;
			GeeArrayList* _tmp51_;
			gint _tmp52_ = 0;
			gpointer* _tmp53_;
			gchar** _tmp54_;
			gint _tmp54__length1;
			gchar* _tmp55_;
			_tmp50_ = *params;
			_tmp51_ = _tmp50_.tags;
			_tmp53_ = gee_collection_to_array ((GeeCollection*) _tmp51_, &_tmp52_);
			_tmp54_ = _tmp53_;
			_tmp54__length1 = _tmp52_;
			_tmp55_ = _vala_g_strjoinv (",", _tmp54_, (gint) _tmp52_);
			_g_free0 (tag_list);
			tag_list = _tmp55_;
			_tmp54_ = (_vala_array_free (_tmp54_, _tmp54__length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp56_ = resource;
		_tmp57_ = tag_list;
		_tmp58_ = string_to_string (_tmp57_);
		_tmp59_ = g_strconcat ("&tagList=", _tmp58_, "&tagExact=true", NULL);
		_tmp60_ = _tmp59_;
		_tmp61_ = g_strconcat (_tmp56_, _tmp60_, NULL);
		_g_free0 (resource);
		resource = _tmp61_;
		_g_free0 (_tmp60_);
		_g_free0 (tag_list);
	}
	_tmp62_ = *params;
	_tmp63_ = _tmp62_.countrycode;
	_tmp64_ = strlen (_tmp63_);
	_tmp65_ = _tmp64_;
	if (_tmp65_ > 0) {
		const gchar* _tmp66_;
		TunerRadioBrowserSearchParams _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		gchar* _tmp72_;
		_tmp66_ = resource;
		_tmp67_ = *params;
		_tmp68_ = _tmp67_.countrycode;
		_tmp69_ = string_to_string (_tmp68_);
		_tmp70_ = g_strconcat ("&countrycode=", _tmp69_, NULL);
		_tmp71_ = _tmp70_;
		_tmp72_ = g_strconcat (_tmp66_, _tmp71_, NULL);
		_g_free0 (resource);
		resource = _tmp72_;
		_g_free0 (_tmp71_);
	}
	_tmp73_ = *params;
	if (_tmp73_.order != TUNER_RADIO_BROWSER_SORT_ORDER_RANDOM) {
		const gchar* _tmp74_;
		TunerRadioBrowserSearchParams _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		gchar* _tmp79_;
		gchar* _tmp80_;
		_tmp74_ = resource;
		_tmp75_ = *params;
		_tmp76_ = bool_to_string (_tmp75_.reverse);
		_tmp77_ = _tmp76_;
		_tmp78_ = g_strconcat ("&reverse=", _tmp77_, NULL);
		_tmp79_ = _tmp78_;
		_tmp80_ = g_strconcat (_tmp74_, _tmp79_, NULL);
		_g_free0 (resource);
		resource = _tmp80_;
		_g_free0 (_tmp79_);
		_g_free0 (_tmp77_);
	}
	_tmp82_ = resource;
	_tmp83_ = tuner_radio_browser_client_get_stations (self, _tmp82_, &_inner_error0_);
	_tmp81_ = _tmp83_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (resource);
			return NULL;
		} else {
			_g_free0 (resource);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp84_ = _tmp81_;
	_tmp81_ = NULL;
	result = _tmp84_;
	_g_object_unref0 (_tmp81_);
	_g_free0 (resource);
	return result;
}

/**
         * @brief Get a station by its UUID
         * @param uuid UUID of the station to retrieve
         * @return Station object if found, null otherwise
         * @throw DataError if unable to retrieve or parse station data
         */
TunerRadioBrowserStation*
tuner_radio_browser_client_by_uuid (TunerRadioBrowserClient* self,
                                    const gchar* uuid,
                                    GError** error)
{
	gchar* resource = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gpointer _tmp5_;
	GError* _inner_error0_ = NULL;
	TunerRadioBrowserStation* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uuid != NULL, NULL);
	_tmp0_ = string_to_string (uuid);
	_tmp1_ = g_strconcat ("json/stations/byuuid/", _tmp0_, NULL);
	resource = _tmp1_;
	_tmp2_ = tuner_radio_browser_client_get_stations (self, resource, &_inner_error0_);
	_result_ = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (resource);
			return NULL;
		} else {
			_g_free0 (resource);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _result_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == 0) {
		result = NULL;
		_g_object_unref0 (_result_);
		_g_free0 (resource);
		return result;
	}
	_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _result_, 0);
	result = (TunerRadioBrowserStation*) _tmp5_;
	_g_object_unref0 (_result_);
	_g_free0 (resource);
	return result;
}

/**
         * @brief Get all available tags
         * @return ArrayList of Tag objects
         * @throw DataError if unable to retrieve or parse tag data
         */
GeeArrayList*
tuner_radio_browser_client_get_tags (TunerRadioBrowserClient* self,
                                     GError** error)
{
	JsonNode* rootnode = NULL;
	GeeArrayList* _tmp28_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	{
		guint status_code = 0U;
		GInputStream* stream = NULL;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		guint _tmp4_ = 0U;
		GInputStream* _tmp5_;
		GInputStream* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		JsonArray* rootarray = NULL;
		JsonArray* _tmp24_;
		JsonArray* _tmp25_;
		GeeArrayList* tags = NULL;
		JsonArray* _tmp26_;
		GeeArrayList* _tmp27_;
		_tmp0_ = self->priv->current_server;
		_tmp1_ = string_to_string (_tmp0_);
		_tmp2_ = g_strconcat (_tmp1_, "/json/tags", NULL);
		_tmp3_ = _tmp2_;
		_tmp5_ = tuner_http_client_GET (_tmp3_, &_tmp4_);
		status_code = _tmp4_;
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp3_);
		stream = _tmp6_;
		_tmp7_ = g_strdup_printf ("%u", status_code);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat ("response from radio-browser.info: ", _tmp8_, NULL);
		_tmp10_ = _tmp9_;
		g_debug ("RadioBrowser.vala:342: %s", _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		{
			JsonParser* parser = NULL;
			JsonParser* _tmp11_;
			JsonParser* _tmp12_;
			GInputStream* _tmp13_;
			JsonParser* _tmp14_;
			JsonNode* _tmp15_;
			JsonNode* _tmp16_;
			_tmp11_ = json_parser_new ();
			parser = _tmp11_;
			_tmp12_ = parser;
			_tmp13_ = stream;
			json_parser_load_from_stream (_tmp12_, _tmp13_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (parser);
				goto __catch1_g_error;
			}
			_tmp14_ = parser;
			_tmp15_ = json_parser_get_root (_tmp14_);
			_tmp16_ = __vala_JsonNode_copy0 (_tmp15_);
			__vala_JsonNode_free0 (rootnode);
			rootnode = _tmp16_;
			_g_object_unref0 (parser);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			GError* _tmp22_;
			GError* _tmp23_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp17_ = e;
			_tmp18_ = _tmp17_->message;
			_tmp19_ = string_to_string (_tmp18_);
			_tmp20_ = g_strconcat ("unable to parse JSON response: ", _tmp19_, NULL);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_error_new_literal (TUNER_RADIO_BROWSER_DATA_ERROR, TUNER_RADIO_BROWSER_DATA_ERROR_PARSE_DATA, _tmp21_);
			_tmp23_ = _tmp22_;
			_g_free0 (_tmp21_);
			_inner_error0_ = _tmp23_;
			_g_error_free0 (e);
			goto __finally1;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (stream);
			goto __catch0_g_error;
		}
		_tmp24_ = json_node_get_array (rootnode);
		_tmp25_ = _json_array_ref0 (_tmp24_);
		rootarray = _tmp25_;
		_tmp26_ = rootarray;
		_tmp27_ = tuner_radio_browser_client_jarray_to_tags (self, _tmp26_);
		tags = _tmp27_;
		result = tags;
		_json_array_unref0 (rootarray);
		_g_object_unref0 (stream);
		__vala_JsonNode_free0 (rootnode);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		g_debug ("RadioBrowser.vala:356: cannot get_tags()");
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			__vala_JsonNode_free0 (rootnode);
			return NULL;
		} else {
			__vala_JsonNode_free0 (rootnode);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp28_ = gee_array_list_new (TUNER_RADIO_BROWSER_TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	result = _tmp28_;
	__vala_JsonNode_free0 (rootnode);
	return result;
}

/**
         */
static TunerRadioBrowserStation*
tuner_radio_browser_client_jnode_to_station (TunerRadioBrowserClient* self,
                                             JsonNode* node)
{
	GObject* _tmp0_;
	TunerRadioBrowserStation* _tmp1_;
	TunerRadioBrowserStation* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	_tmp0_ = json_gobject_deserialize (TUNER_RADIO_BROWSER_TYPE_STATION, node);
	_tmp1_ = TUNER_RADIO_BROWSER_IS_STATION (_tmp0_) ? ((TunerRadioBrowserStation*) _tmp0_) : NULL;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (_tmp0_);
	}
	result = _tmp1_;
	return result;
}

/**
         */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		TunerRadioBrowserClient* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->stations);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
__lambda32_ (Block4Data* _data4_,
             JsonArray* array,
             guint index,
             JsonNode* element)
{
	TunerRadioBrowserClient* self;
	TunerRadioBrowserStation* s = NULL;
	TunerRadioBrowserStation* _tmp0_;
	self = _data4_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (element != NULL);
	_tmp0_ = tuner_radio_browser_client_jnode_to_station (self, element);
	s = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _data4_->stations, s);
	_g_object_unref0 (s);
}

static void
___lambda32__json_array_foreach (JsonArray* array,
                                 guint index_,
                                 JsonNode* element_node,
                                 gpointer self)
{
	__lambda32_ (self, array, index_, element_node);
}

static GeeArrayList*
tuner_radio_browser_client_jarray_to_stations (TunerRadioBrowserClient* self,
                                               JsonArray* data)
{
	Block4Data* _data4_;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = gee_array_list_new (TUNER_RADIO_BROWSER_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data4_->stations = _tmp0_;
	json_array_foreach_element (data, ___lambda32__json_array_foreach, _data4_);
	_tmp1_ = _g_object_ref0 (_data4_->stations);
	result = _tmp1_;
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return result;
}

/**
         */
static TunerRadioBrowserTag*
tuner_radio_browser_client_jnode_to_tag (TunerRadioBrowserClient* self,
                                         JsonNode* node)
{
	GObject* _tmp0_;
	TunerRadioBrowserTag* _tmp1_;
	TunerRadioBrowserTag* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	_tmp0_ = json_gobject_deserialize (TUNER_RADIO_BROWSER_TYPE_TAG, node);
	_tmp1_ = TUNER_RADIO_BROWSER_IS_TAG (_tmp0_) ? ((TunerRadioBrowserTag*) _tmp0_) : NULL;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (_tmp0_);
	}
	result = _tmp1_;
	return result;
}

/**
         */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		TunerRadioBrowserClient* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->tags);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static void
__lambda63_ (Block5Data* _data5_,
             JsonArray* array,
             guint index,
             JsonNode* element)
{
	TunerRadioBrowserClient* self;
	TunerRadioBrowserTag* s = NULL;
	TunerRadioBrowserTag* _tmp0_;
	self = _data5_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (element != NULL);
	_tmp0_ = tuner_radio_browser_client_jnode_to_tag (self, element);
	s = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _data5_->tags, s);
	_g_object_unref0 (s);
}

static void
___lambda63__json_array_foreach (JsonArray* array,
                                 guint index_,
                                 JsonNode* element_node,
                                 gpointer self)
{
	__lambda63_ (self, array, index_, element_node);
}

static GeeArrayList*
tuner_radio_browser_client_jarray_to_tags (TunerRadioBrowserClient* self,
                                           JsonArray* data)
{
	Block5Data* _data5_;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = gee_array_list_new (TUNER_RADIO_BROWSER_TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data5_->tags = _tmp0_;
	json_array_foreach_element (data, ___lambda63__json_array_foreach, _data5_);
	_tmp1_ = _g_object_ref0 (_data5_->tags);
	result = _tmp1_;
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return result;
}

/**
        * @brief Get all radio-browser.info API servers
        *
        * Gets server list from 
        *
        * @since 1.5.4
        * @return ArrayList of strings containing the resolved hostnames
        * @throw DataError if unable to resolve DNS records
        */
static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		TunerRadioBrowserClient* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->results);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static GSrvTarget*
_vala_GSrvTarget_copy (GSrvTarget* self)
{
	return g_boxed_copy (g_srv_target_get_type (), self);
}

static gpointer
__vala_GSrvTarget_copy0 (gpointer self)
{
	return self ? _vala_GSrvTarget_copy (self) : NULL;
}

static void
_vala_GSrvTarget_free (GSrvTarget* self)
{
	g_boxed_free (g_srv_target_get_type (), self);
}

static void
__vala_GSrvTarget_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GSrvTarget_free (var), NULL));
}

static inline void
_g_list_free___vala_GSrvTarget_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_GSrvTarget_free0_);
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static void
______lambda62_ (Block6Data* _data6_,
                 JsonArray* array,
                 guint index_,
                 JsonNode* element_node)
{
	TunerRadioBrowserClient* self;
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	JsonObject* _tmp2_;
	self = _data6_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (element_node != NULL);
	_tmp0_ = json_node_get_object (element_node);
	_tmp1_ = _json_object_ref0 (_tmp0_);
	object = _tmp1_;
	_tmp2_ = object;
	if (_tmp2_ != NULL) {
		gchar* name = NULL;
		JsonObject* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
		_tmp3_ = object;
		_tmp4_ = json_object_get_string_member (_tmp3_, "name");
		_tmp5_ = g_strdup (_tmp4_);
		name = _tmp5_;
		_tmp7_ = name;
		if (_tmp7_ != NULL) {
			const gchar* _tmp8_;
			_tmp8_ = name;
			_tmp6_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _data6_->results, _tmp8_);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			const gchar* _tmp9_;
			_tmp9_ = name;
			gee_abstract_collection_add ((GeeAbstractCollection*) _data6_->results, _tmp9_);
		}
		_g_free0 (name);
	}
	_json_object_unref0 (object);
}

static void
_______lambda62__json_array_foreach (JsonArray* array,
                                     guint index_,
                                     JsonNode* element_node,
                                     gpointer self)
{
	______lambda62_ (self, array, index_, element_node);
}

static GeeArrayList*
tuner_radio_browser_client_get_api_servers (TunerRadioBrowserClient* self,
                                            GError** error)
{
	Block6Data* _data6_;
	GeeArrayList* _tmp0_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GeeArrayList* _tmp44_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_data6_->results = _tmp0_;
	{
		GList* srv_targets = NULL;
		GResolver* _tmp1_;
		GResolver* _tmp2_;
		GList* _tmp3_;
		GList* _tmp4_;
		_tmp1_ = g_resolver_get_default ();
		_tmp2_ = _tmp1_;
		_tmp3_ = g_resolver_lookup_service (_tmp2_, TUNER_RADIO_BROWSER_SRV_SERVICE, TUNER_RADIO_BROWSER_SRV_PROTOCOL, TUNER_RADIO_BROWSER_SRV_DOMAIN, NULL, &_inner_error0_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		srv_targets = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		{
			GList* target_collection = NULL;
			GList* target_it = NULL;
			target_collection = srv_targets;
			for (target_it = target_collection; target_it != NULL; target_it = target_it->next) {
				GSrvTarget* _tmp5_;
				GSrvTarget* target = NULL;
				_tmp5_ = __vala_GSrvTarget_copy0 ((GSrvTarget*) target_it->data);
				target = _tmp5_;
				{
					GSrvTarget* _tmp6_;
					const gchar* _tmp7_;
					_tmp6_ = target;
					_tmp7_ = g_srv_target_get_hostname (_tmp6_);
					gee_abstract_collection_add ((GeeAbstractCollection*) _data6_->results, _tmp7_);
					__vala_GSrvTarget_free0 (target);
				}
			}
		}
		(srv_targets == NULL) ? NULL : (srv_targets = (_g_list_free___vala_GSrvTarget_free0_ (srv_targets), NULL));
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		_tmp10_ = string_to_string (_tmp9_);
		_tmp11_ = g_strconcat ("Unable to resolve Radio-Browser SRV records: ", _tmp10_, NULL);
		_tmp12_ = _tmp11_;
		g_warning ("RadioBrowser.vala:424: %s", _tmp12_);
		_g_free0 (_tmp12_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			block6_data_unref (_data6_);
			_data6_ = NULL;
			return NULL;
		} else {
			block6_data_unref (_data6_);
			_data6_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp13_ = gee_collection_get_is_empty ((GeeCollection*) _data6_->results);
	_tmp14_ = _tmp13_;
	if (_tmp14_) {
		{
			guint status_code = 0U;
			GInputStream* stream = NULL;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			guint _tmp18_ = 0U;
			GInputStream* _tmp19_;
			GInputStream* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			_tmp15_ = string_to_string (TUNER_RADIO_BROWSER_ALL_API);
			_tmp16_ = g_strconcat (_tmp15_, "/json/servers", NULL);
			_tmp17_ = _tmp16_;
			_tmp19_ = tuner_http_client_GET (_tmp17_, &_tmp18_);
			status_code = _tmp18_;
			_tmp20_ = _tmp19_;
			_g_free0 (_tmp17_);
			stream = _tmp20_;
			_tmp21_ = string_to_string (TUNER_RADIO_BROWSER_ALL_API);
			_tmp22_ = g_strdup_printf ("%u", status_code);
			_tmp23_ = _tmp22_;
			_tmp24_ = g_strconcat ("response from ", _tmp21_, "/json/servers: ", _tmp23_, NULL);
			_tmp25_ = _tmp24_;
			g_debug ("RadioBrowser.vala:437: %s", _tmp25_);
			_g_free0 (_tmp25_);
			_g_free0 (_tmp23_);
			if (status_code == ((guint) 200)) {
				JsonNode* root_node = NULL;
				gboolean _tmp39_ = FALSE;
				JsonNode* _tmp40_;
				{
					JsonParser* parser = NULL;
					JsonParser* _tmp26_;
					JsonParser* _tmp27_;
					GInputStream* _tmp28_;
					JsonParser* _tmp29_;
					JsonNode* _tmp30_;
					JsonNode* _tmp31_;
					_tmp26_ = json_parser_new ();
					parser = _tmp26_;
					_tmp27_ = parser;
					_tmp28_ = stream;
					json_parser_load_from_stream (_tmp27_, _tmp28_, NULL, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (parser);
						goto __catch2_g_error;
					}
					_tmp29_ = parser;
					_tmp30_ = json_parser_get_root (_tmp29_);
					_tmp31_ = __vala_JsonNode_copy0 (_tmp30_);
					__vala_JsonNode_free0 (root_node);
					root_node = _tmp31_;
					_g_object_unref0 (parser);
				}
				goto __finally2;
				__catch2_g_error:
				{
					GError* e = NULL;
					GError* _tmp32_;
					const gchar* _tmp33_;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
					GError* _tmp37_;
					GError* _tmp38_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp32_ = e;
					_tmp33_ = _tmp32_->message;
					_tmp34_ = string_to_string (_tmp33_);
					_tmp35_ = g_strconcat ("unable to parse JSON response: ", _tmp34_, NULL);
					_tmp36_ = _tmp35_;
					_tmp37_ = g_error_new_literal (TUNER_RADIO_BROWSER_DATA_ERROR, TUNER_RADIO_BROWSER_DATA_ERROR_PARSE_DATA, _tmp36_);
					_tmp38_ = _tmp37_;
					_g_free0 (_tmp36_);
					_inner_error0_ = _tmp38_;
					_g_error_free0 (e);
					goto __finally2;
				}
				__finally2:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					__vala_JsonNode_free0 (root_node);
					_g_object_unref0 (stream);
					goto __catch1_g_error;
				}
				_tmp40_ = root_node;
				if (_tmp40_ != NULL) {
					JsonNode* _tmp41_;
					_tmp41_ = root_node;
					_tmp39_ = json_node_get_node_type (_tmp41_) == JSON_NODE_ARRAY;
				} else {
					_tmp39_ = FALSE;
				}
				if (_tmp39_) {
					JsonNode* _tmp42_;
					JsonArray* _tmp43_;
					_tmp42_ = root_node;
					_tmp43_ = json_node_get_array (_tmp42_);
					json_array_foreach_element (_tmp43_, _______lambda62__json_array_foreach, _data6_);
				}
				__vala_JsonNode_free0 (root_node);
			}
			_g_object_unref0 (stream);
		}
		goto __finally1;
		__catch1_g_error:
		{
			g_clear_error (&_inner_error0_);
			g_warning ("RadioBrowser.vala:466: Failed to parse APIs JSON response: $(e.message" \
")");
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == TUNER_RADIO_BROWSER_DATA_ERROR) {
				g_propagate_error (error, _inner_error0_);
				block6_data_unref (_data6_);
				_data6_ = NULL;
				return NULL;
			} else {
				block6_data_unref (_data6_);
				_data6_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp44_ = _g_object_ref0 (_data6_->results);
	result = _tmp44_;
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return result;
}

static void
tuner_radio_browser_client_class_init (TunerRadioBrowserClientClass * klass,
                                       gpointer klass_data)
{
	tuner_radio_browser_client_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerRadioBrowserClient_private_offset);
	G_OBJECT_CLASS (klass)->finalize = tuner_radio_browser_client_finalize;
}

static void
tuner_radio_browser_client_instance_init (TunerRadioBrowserClient * self,
                                          gpointer klass)
{
	self->priv = tuner_radio_browser_client_get_instance_private (self);
}

static void
tuner_radio_browser_client_finalize (GObject * obj)
{
	TunerRadioBrowserClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_RADIO_BROWSER_TYPE_CLIENT, TunerRadioBrowserClient);
	_g_free0 (self->priv->current_server);
	G_OBJECT_CLASS (tuner_radio_browser_client_parent_class)->finalize (obj);
}

/**
     * @class Client
     * @brief RadioBrowser API Client
     *
     * This class provides methods to interact with the RadioBrowser API, including
     * searching for stations, retrieving station information, and managing user actions.
     */
static GType
tuner_radio_browser_client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerRadioBrowserClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_radio_browser_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerRadioBrowserClient), 0, (GInstanceInitFunc) tuner_radio_browser_client_instance_init, NULL };
	GType tuner_radio_browser_client_type_id;
	tuner_radio_browser_client_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerRadioBrowserClient", &g_define_type_info, 0);
	TunerRadioBrowserClient_private_offset = g_type_add_instance_private (tuner_radio_browser_client_type_id, sizeof (TunerRadioBrowserClientPrivate));
	return tuner_radio_browser_client_type_id;
}

GType
tuner_radio_browser_client_get_type (void)
{
	static volatile gsize tuner_radio_browser_client_type_id__once = 0;
	if (g_once_init_enter (&tuner_radio_browser_client_type_id__once)) {
		GType tuner_radio_browser_client_type_id;
		tuner_radio_browser_client_type_id = tuner_radio_browser_client_get_type_once ();
		g_once_init_leave (&tuner_radio_browser_client_type_id__once, tuner_radio_browser_client_type_id);
	}
	return tuner_radio_browser_client_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

